<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id$ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/)
 *   2002-2007 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
/* Check permission */
if (!$oSess->is('sys_settings'))
{
	return;
}
/* Script variables below */
/* Script functions below */
function gw_show_form()
{
	global $oFunc, $sys, $oL, $gw_this;
	$arStatus = array();
	$arStatus[] = array(sprintf('<b>%s</b>', $oL->m('9_remove')),
					sprintf(
					'<a href="%s">%s</a>',
					append_url($sys['page_admin'].'?'.GW_ACTION.'='.GW_A_MAINTENANCE.'&'.GW_TARGET.'='.GW_T_SYSTEM.'&tid='.$gw_this['vars']['tid'].'&w1=1'),
					$oL->m('1185')
				));
	return $arStatus;
}
/* */
function gw_export_sqltable($tablename)
{
	global $sys, $oDb, $oFunc, $oL;
	$tablename = $sys['tbl_prefix'].$tablename;

	$filename = $sys['path_export'] . '/sql_backup_' . date("Y-mM-d") .'/backup_' . $tablename . '.sql';
	$strQ = '';
	$strQ .= 'SET CHARACTER SET utf8;' . CRLF;
	$strQ .= 'DROP TABLE IF EXISTS `' . $tablename . '`;' . CRLF;
	$sql = 'SHOW CREATE TABLE `' . $tablename . '`';
	$arSql = $oDb->sqlExec($sql);
	$strQ .= $arSql[0]['Create Table'].';'.CRLF;
	$q_mysql = 'SQL_BIG_RESULT';
	$sql = 'SELECT '.$q_mysql.' * FROM `' . $tablename . '`';
	$arSql = $oDb->sqlExec($sql);
	/* */
	for (; list($arK, $arV) = each($arSql);)
	{
		for (reset($arV); list($kV, $vV) = each($arV);)
		{
		if (($arV[$kV] != '') && preg_match('/(word_|abbr_|settings|code|topic|page_|character|term|defn)/', $kV))
			{
				$arV[$kV] = '0x' . bin2hex($arV[$kV]);
			}
		}
		$strQ .= gw_sql_insert($arV, $tablename, 0) . ';';
	}
	$isWrite = $oFunc->file_put_contents( $filename, $strQ, 'w');
	return ( $isWrite ?  '<span class="xt"><span class="gray">'. $filename . '</span><br />' . $oFunc->number_format(strlen($strQ), 0, $oL->languagelist(4)) . ' ' . $oL->m('bytes'): $oL->m('error') ).'</span>';
}
/* */
function gw_backup()
{
	global $oFunc, $sys, $oL, $gw_this;
	$arStatus = array();
	@set_time_limit(3600);
	switch ($gw_this['vars']['w1'])
	{
		case 1:
			$arTables = array('abbr', 'abbr_phrase', 'auth', 'component', 'component_menu',
				'dict', 'map_user_to_dict', 'map_user_to_term', 'pages', 'pages_phrase', 'search_results',
				'sessions', 'settings', 'stat_dict', 'stat_search', 'theme', 'theme_group',
				'theme_settings', 'toolbar', 'topics', 'topics_phrase', 'users'
			);
		break;
		case 2:
			for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
			{
				/* I have to remove table prefix from dictionary table name */
				$arTables[] = str_replace($sys['tbl_prefix'],'', $vDict['tablename']);
			}
		break;
		case 3:
			$arTables = array('wordlist');
		break;
		case 4:
			$arTables = array('wordmap');
		break;
		default:
		  $arTables = array();
		break;
	}
	$gw_this['vars']['w1']++;
	/* */
	for (; list($k, $v) = each($arTables);)
	{
		$arStatus[] = array($v, gw_export_sqltable($v));
	}
	/* */
	if ($gw_this['vars']['w1'] < 5)
	{
		$arStatus[] = array('', sprintf(
					'<a href="%s">%s</a>',
					append_url($sys['page_admin'].'?'.GW_ACTION.'='.GW_A_MAINTENANCE.'&'.GW_TARGET.'='.GW_T_SYSTEM.'&tid='.$gw_this['vars']['tid'].'&w1='.$gw_this['vars']['w1']),
					$oL->m('1185')
				));
	}
	else
	{
		$arStatus[] = array('', $oL->m('2_success'));
	}
	return $arStatus;
}
/* Script action below */
$strR .= getFormTitleNav($oL->m('1266'));
$strR .= '<div class="contents xu">';
if ($gw_this['vars']['w1'])
{
	$strR .= html_array_to_table_multi(gw_backup());
}
else
{
	$strR .= html_array_to_table_multi(gw_show_form());
}
	$strR .= '</div>';
/* end of file */
?>