<?php
/**
 *  $Id$
 */
/**
 *  Glossword - glossary compiler (http://glossword.info/)
 *   2002-2007 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
/**
 * Login process.
 */
/* Turn on any warnings */
error_reporting(E_ALL);
/* Load login configuration */
if (!include("login.cfg.php"))
{
	print 'sys: Can\'t include login.cfg.php. Check configuration.';
	exit;
}
/* Change current directory to access for website files */
if (!chdir($path['doc_root']))
{
	print 'sys: Can\'t change directory to ' . $path['doc_root']. '. Check login.cfg.php';
	exit;
}
/* ------------------------------------------------------- */
/* Load configuration */
$sys['is_prepend'] = 1;
include_once('db_config.php');
include_once($sys['path_include_local'] . '/config.inc.php');

/* Allow user when installation is locked */
#if (!file_exists($sys['file_lock']))
#{
#	print 'Installer is not locked';
#	exit;
#}
if (!defined('GW_DB_HOST'))
{
	print "sys: Can't find config.inc.php GW_DB_HOST is not defined.";
	exit;
}
/* */
include_once( $sys['path_include'] . '/class.forms.php');
include_once( $sys['path_include'] . '/func.admin.inc.php');
/* --------------------------------------------------------
 * Database -> Query storage
 * ----------------------------------------------------- */
$oSqlQ = new $sys['class_queries'];
$oSqlQ->set_suffix('-'.$sys['db_type']);
/* ------------------------------------------------------- */
/* Append system settings */
$sys = array_merge($sys, getSettings());
/* Fill empty settings */
$sys['visualtheme'] = isset($sys['visualtheme']) ? $sys['visualtheme'] : 'gw_admin';
/* Auto time for server  */
$sys['time_now'] = mktime();
$is_dst = intval(date('I', $sys['time_now']) - date('I'));
$sys['server_gmt_offset'] = $is_dst ? date('Z') : ( date('Z') / 3600) - 1;
$sys['time_now_gmt_unix'] = $sys['time_now'] - ($sys['server_gmt_offset'] * 3600);
$tmps = array();
/* --------------------------------------------------------
 * mod_rewrite configuration
 * ------------------------------------------------------- */
$sys['is_mod_rewrite'] = 0;
$oHtml = new gw_html;
$oHtml->setVar('is_htmlspecialchars', 0);
$oHtml->setVar('is_mod_rewrite', $sys['is_mod_rewrite']);
$oHtml->is_append_sid = 1;
$oHtml->id_sess_name = GW_SID;

/* --------------------------------------------------------
 * Register global variables
 * ----------------------------------------------------- */
$gw_this['vars'] = $oGlobals->register(array(
	GW_ACTION,GW_ID_DICT,'p','r',GW_TARGET,'arPost','visualtheme',
	'id','cookie',GW_SID,'post','actkey',
	GW_LANG_I, GW_LANG_C
));
##------------------------------------------------
$gw_this['vars']['visualtheme'] = 'gw_admin';

/* Translation engine */
$oL = new gwtk;
$oL->setHomeDir($sys['path_locale']);
$oL->setLocale($sys['locale_name']);
$oL->getCustom('admin', $sys['locale_name'], 'join');
$oL->getCustom('err', $sys['locale_name'], 'join');
$oL->getCustom('mail', $sys['locale_name'], 'join');
/* Redirect URL */
$url_admin = $sys['server_proto'] . $sys['server_host'] .  $sys['page_admin'];
#print $url_admin;
/* --------------------------------------------------------
 * Template engine
 * ------------------------------------------------------- */
$oTpl = new $sys['class_tpl'];
$oTpl->init('gw_admin');
$oTpl->is_tpl_show_names = $sys['is_tpl_show_names'];
$oTpl->addVal( 'v:language',         $oL->languagelist("0") );
$oTpl->addVal( 'v:text_direction',   $oL->languagelist("1") );
$oTpl->addVal( 'v:charset',          $oL->languagelist("2") );
$oTpl->addVal( 'v:top_right',        $oL->m('securenote') );
$oTpl->addVal( 'href:home',          $sys['server_dir'].'/index.php' );
#$oTpl->addVal( 'url:title_page',     $oHtml->a($sys['page_index'], $oL->m('3_tomain')) );
$oTpl->addVal( 'l:top_of_page',      $oL->m('3_top') );
$oTpl->addVal( 'v:glossword_version',$sys['version']);
$oTpl->addVal( 'v:html_title',       $sys['site_name'] . $sys['txt_sep_htmltitle'] . $oL->m('2_login') );
$oTpl->addVal( 'v:path_css_script',  $sys['path_css_script'] );
$oTpl->addVal( 'v:path_img',         $sys['path_img'] );
$oTpl->addVal( 'v:site_name',        $sys['site_name']);
$oTpl->addVal( 'v:path_css',         $sys['server_dir'].'/'.$sys['path_tpl'].'/'.$gw_this['vars']['visualtheme'] );
$oTpl->addVal( 'v:lang_i_name',      GW_LANG_I );
$oTpl->addVal( 'v:lang_i_value',     $gw_this['vars'][GW_LANG_I] );
/* I request you to retain the copyright notice! */
$oTpl->addVal( 'v:copyright',        'Powered&#160;by <a href="http://glossword.info/">Glossword</a>&#160;' );

$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
if ($oL->languagelist('1') == 'rtl')
{
	$sys['css_align_right'] = 'left';
	$sys['css_align_left'] = 'right';
}
$oTpl->addVal( 'v:css_align_right', $sys['css_align_right']);
$oTpl->addVal( 'v:css_align_left',  $sys['css_align_left']);

/* 24 jan 2006: load theme setting from database */
$ar_theme = gw_get_theme($gw_this['vars']['visualtheme']);
$oTpl->addVal( 'v:visualtheme', str_replace('_', '-', $gw_this['vars']['visualtheme']) );

$tmp['ar_req'] = array('user_name', 'user_pass');
/* */
$gw_this['str_status'] = '';

/* Start session */
$oSess = new $sys['class_session'];
/* Session-protected area below */
$oSess->start();
/* Activation key  */
if ($gw_this['vars']['actkey'])
{
	/*
		1) get login, email, name based on activation key
		2) create password
		3) create mail message
		4) send mail
		5) update database
		6) redirect to login page
	*/
	$sql = $oSqlQ->getQ('get-user-by-actkey', $gw_this['vars']['actkey']);
	$arSql = $oDb->sqlExec($sql);
	$tmps['is_exists'] = 0;
	while (list($k, $arV) = each($arSql))
	{
		$tmps['is_exists'] = 1;
		$tmps['id_auth'] = $arV['id_auth'];
		$tmps['user_name'] = $arV['user_name'];
		$tmps['user_email'] = $arV['user_email'];
		$tmps['login'] = $arV['login'];
	}
	if ($tmps['is_exists'])
	{
		$login_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'];
		$login_url = '<a href="'.$login_url.'" onclick="window.open(this.href);return false;">'.$login_url.'</a>';
		$str_pass = kMakeUid('', 8, 1);
		/* Prepare message */
		/* User name, URL, login, password, message template */
		$msgBody = gwCreateMessage($tmps['user_name'], $login_url, $tmps['login'], $str_pass, 'mail_newuser.html');
		if (!kMailTo($tmps['user_email'], $sys['y_email'], '', $msgBody, 0))
		{
			$gw_this['str_status'] .= '<p><span class="s"><b>' .sprintf($oL->m('reason_17'), $tmps['user_email']). '</b></span></p>';
			/* display login and password */
			$gw_this['str_status'] .= '<p>'.$oL->m('login'). ': <b>' . $tmps['login'] . '</b><br /> '.
				 $oL->m('password'). ': <b>' . $str_pass . '</b></p>';
		}
		/* Set new password */
		$sql1 = $oSqlQ->getQ('set-password', md5($str_pass), $tmps['id_auth']);
		$sql2 = $oSqlQ->getQ('set-user-active', '1', '', $tmps['id_auth']);
		/* Activate account */
		if ($oDb->sqlExec($sql1) && $oDb->sqlExec($sql2))
		{
			$gw_this['str_status'] .= '<p>' . $oL->m('reason_24') . '</p>';
		}
	}
	else
	{
		$gw_this['str_status'] .= '<p><span class="s"><b>' . $oL->m('reason_23') . '</b></span></p>';
	}
#	$gw_this['vars']['post'] = 1;
}
/* */
if ($oSess->user_get('perm_level') > 1)
{
	/* Auth successful */
	gwtk_header(append_url($url_admin), $sys['is_delay_redirect']);
}
/* Not posted */
if ($gw_this['vars']['post'] == '')
{
	$gw_this['vars']['arPost']['user_name'] =
	$gw_this['vars']['arPost']['user_pass'] =
	$gw_this['vars']['arPost']['user_email'] = '';
	$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
}
else
{
	$gw_this['vars']['arPost']['user_pass'] = isset($gw_this['vars']['arPost']['user_pass'])
											? $gw_this['vars']['arPost']['user_pass']
											: '';
	if ($gw_this['vars'][GW_ACTION] == 'login')
	{ 
		/* Check login & pass  */
		/* Set default error */
		$gw_this['str_status'] = '<p>' . $oL->m('reason_20') . '</p>';
		switch ($oSess->auth_login($gw_this['vars']['arPost']))
		{
			case 0:
				/* Login failed */
				$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
			break;
			case 1:
				/* Login successful */
				gwtk_header(append_url($url_admin), $sys['is_delay_redirect']);
			break;
			case 2:
				/* Inactive account */
				$gw_this['str_status'] = '<p>' . $oL->m('reason_21') . '</p>';
				$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
			break;
		}
	}
	elseif ($gw_this['vars'][GW_ACTION] == 'lostpass')
	{
		$sql = $oSqlQ->getQ('cmp-login-email', $gw_this['vars']['arPost']['user_name'], $gw_this['vars']['arPost']['user_email']);
		$arSql = $oDb->sqlExec($sql);
		$tmps['is_exists'] = 0;
		$tmps['id_auth'] = 0;

		while (list($k, $arV) = each($arSql))
		{
			$tmps['is_exists'] = 1;
			$tmps['id_auth'] = $arV['id_auth'];
			$tmps['login'] = $arV['login'];
		}
		if ($tmps['is_exists'])
		{
			/* Create new password */
			$gw_this['str_status'] = '<p>'.$oL->m('reason_22').'</p>';
			$actkey = kMakeUid('k', $maxchar = 16, 1);
			$actkey_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'] . '?' . 'actkey=' . $actkey;
			$actkey_url = '<a href="'.$actkey_url.'">'.$actkey_url.'</a>';
			$mail_sig = $sys['site_name'] . ' - ' . $sys['site_desc'];
			$arSrc = array('{USERNAME}', '{SITENAME}', '{U_ACTIVATE}');
			$arTrg = array($tmps['login'], $sys['site_name'], $actkey_url);
			$mail_message = str_replace($arSrc, $arTrg, $oL->m('mail_newpass'));
			$mail_subject = str_replace($arSrc, $arTrg, $oL->m('mail_newpass_subj'));
			/* */
			$oTplMail = new $sys['class_tpl'];
			$oTplMail->init('gw_admin');
			$oTplMail->addVal( 'v:language',         $oL->languagelist("0") );
			$oTplMail->addVal( 'v:text_direction',   $oL->languagelist("1") );
			$oTplMail->addVal( 'v:charset',          $oL->languagelist("2") );
			$oTplMail->addVal( 'v:email_signature',  $mail_sig );
			$oTplMail->addVal( 'v:message',          $mail_message );
			$oTplMail->addVal( 'v:subject',          $mail_subject );
			/* I request you to retain the copyright notice! */
			$oTplMail->addVal( 'v:copyright',        'Powered&#160;by <a href="http://glossword.info/">Glossword</a>&#160;' );
			$oTplMail->set_tpl(GW_TPL_MAIL);
			$oTplMail->parse();
			$str_mailbody = $oTplMail->output();
			/* */
			if (!kMailTo($gw_this['vars']['arPost']['user_email'], $sys['y_email'], $mail_subject, $str_mailbody, 0))
			{
				$gw_this['str_status'] .= '<p><span class="s"><b>'.sprintf($oL->m('reason_17'), $gw_this['vars']['arPost']['user_email']).'</b></span></p>';
				/* display activation key */
				$gw_this['str_status'] .= '<p>' . $actkey_url . '</p>';
			}
			/* Disable account and set activation key */
			$sql = $oSqlQ->getQ('set-user-active', '0', $actkey, $tmps['id_auth']);
			$oDb->sqlExec($sql);
		}
		else
		{
			/* No such account */
			$gw_this['str_status'] = '<p>'.$oL->m('reason_20').'</p>';
		}
		$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
	}
}
/* Current status */
$oTpl->addVal('non::objStatus', $gw_this['str_status']);
/* Render page */
$oTpl->set_tpl(GW_TPL_LOGIN);

/* Content-type for XHTML 1.1 */
#$sys['content_type'] = preg_match("/application\/xhtml\+xml/", $_SERVER['HTTP_ACCEPT']) ? 'application/xhtml+xml' : $sys['content_type'];
$oTpl->addVal( 'v:content_type', $sys['content_type'] );

$oTpl->parse();
$oHdr->add('Expires: ' . date("D, d M Y H:i:s", $sys['time_now_gmt_unix']) . ' GMT');
$oHdr->add('Last-Modified: ' . date("D, d M Y H:i:s", $sys['time_now_gmt_unix']) . ' GMT');
$oHdr->add('Cache-Control: no-cache, must-revalidate');
$oHdr->add('Pragma: no-cache');
$oHdr->add('Content-Type: '.$sys['content_type'].'; charset='.$oL->languagelist('2'));
$oHdr->output();
print $oTpl->output();
/* Close session */
$oSess->user_close();
/* end of file */
?>