
DROP TABLE IF EXISTS `{PREFIX}abbr`;
CREATE TABLE `{PREFIX}abbr` (
  `id_abbr` tinyint(3) unsigned NOT NULL auto_increment,
  `is_active` enum('0','1') NOT NULL default '1',
  `id_dict` tinyint(3) unsigned NOT NULL default '0',
  `id_group` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_abbr`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `{PREFIX}abbr_phrase`;
CREATE TABLE `{PREFIX}abbr_phrase` (
  `id_abbr_phrase` int(10) unsigned NOT NULL auto_increment,
  `id_abbr` int(10) unsigned NOT NULL default '0',
  `id_lang` varchar(32) NOT NULL default 'en-utf8',
  `abbr_short` varbinary(255) NOT NULL default '',
  `abbr_long` varbinary(255) NOT NULL default '',
  PRIMARY KEY  (`id_abbr_phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}auth`;
CREATE TABLE `{PREFIX}auth` (
  `id_auth` int(10) unsigned NOT NULL auto_increment,
  `login` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `perm_bits` varchar(16) NOT NULL default '10010010000000',
  PRIMARY KEY  (`id_auth`),
  UNIQUE KEY `login` (`login`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `{PREFIX}captcha`;
CREATE TABLE `{PREFIX}captcha` (
  `id` int(11) NOT NULL auto_increment,
  `date_created` int(11) NOT NULL,
  `captcha` varchar(5) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `captcha` (`captcha`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `{PREFIX}component`;
CREATE TABLE `{PREFIX}component` (
  `id_component` varchar(32) NOT NULL default '',
  `is_active` enum('0','1') NOT NULL default '1',
  `int_sort` mediumint(5) NOT NULL default '10',
  `php_code` blob NOT NULL,
  `vv1` int(3) unsigned NOT NULL default '1',
  `vv2` int(3) unsigned NOT NULL default '0',
  `vv3` int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_component`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}component_menu`;
CREATE TABLE `{PREFIX}component_menu` (
  `id_a_menu` int(3) unsigned NOT NULL auto_increment,
  `id_component` varchar(32) NOT NULL default '',
  `id_action` varchar(32) NOT NULL default '',
  `condition` varchar(255) NOT NULL default '',
  `icon` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id_a_menu`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}dict`;
CREATE TABLE `{PREFIX}dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `id_topic` tinyint(3) unsigned NOT NULL default '1',
  `is_active` enum('0','1') NOT NULL default '0',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `lang` varchar(12) NOT NULL default 'en-utf8',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_terms` mediumint(8) unsigned NOT NULL default '0',
  `int_bytes` int(12) unsigned NOT NULL default '0',
  `tablename` varchar(32) NOT NULL default '',
  `visualtheme` varchar(64) NOT NULL default 'gw_silver',
  `title` varbinary(255) NOT NULL default '',
  `announce` varbinary(255) NOT NULL default '',
  `description` blob NOT NULL,
  `keywords` varbinary(255) NOT NULL default '',
  `dict_settings` blob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}map_user_to_dict`;
CREATE TABLE `{PREFIX}map_user_to_dict` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` smallint(5) unsigned NOT NULL default '1',
  `dict_id` smallint(5) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}map_user_to_term`;
CREATE TABLE `{PREFIX}map_user_to_term` (
  `user_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` mediumint(5) unsigned NOT NULL default '0',
  UNIQUE KEY `utd` (`user_id`,`term_id`,`dict_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}pages`;
CREATE TABLE `{PREFIX}pages` (
  `id_page` tinyint(3) unsigned NOT NULL auto_increment,
  `is_active` enum('0','1') NOT NULL default '1',
  `int_sort` tinyint(3) NOT NULL default '10',
  `id_parent` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `page_icon` varchar(64) NOT NULL default '',
  `page_uri` varchar(255) NOT NULL default '',
  `page_php_1` mediumblob NOT NULL,
  `page_php_2` tinyblob NOT NULL,
  PRIMARY KEY  (`id_page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}pages_phrase`;
CREATE TABLE `{PREFIX}pages_phrase` (
  `id_page_phrase` mediumint(5) unsigned NOT NULL auto_increment,
  `id_page` tinyint(3) unsigned NOT NULL default '0',
  `id_lang` varchar(10) NOT NULL default 'en-utf8',
  `page_title` varbinary(255) NOT NULL default '',
  `page_keywords` blob NOT NULL,
  `page_descr` mediumblob NOT NULL,
  `page_content` mediumblob NOT NULL,
  PRIMARY KEY  (`id_page_phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}search_results`;
CREATE TABLE `{PREFIX}search_results` (
  `id_srch` varchar(32) NOT NULL default '',
  `id_d` mediumint(5) unsigned NOT NULL default '0',
  `srch_date` int(10) unsigned NOT NULL default '0',
  `found` int(10) unsigned NOT NULL default '1',
  `hits` mediumint(5) unsigned NOT NULL default '0',
  `q` varbinary(255) NOT NULL default '',
  `srch_settings` mediumblob NOT NULL,
  PRIMARY KEY  (`id_srch`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}sessions`;
CREATE TABLE `{PREFIX}sessions` (
  `id_sess` varchar(32) NOT NULL default '',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `changed` int(10) unsigned NOT NULL default '0',
  `sess_settings` blob,
  `ip` int(10) unsigned NOT NULL default '0',
  `ua` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id_sess`),
  KEY `changed` (`changed`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}settings`;
CREATE TABLE `{PREFIX}settings` (
  `settings_key` varchar(127) NOT NULL default '',
  `settings_val` mediumblob NOT NULL,
  PRIMARY KEY  (`settings_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}stat_dict`;
CREATE TABLE `{PREFIX}stat_dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `hits` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}stat_search`;
CREATE TABLE `{PREFIX}stat_search` (
  `id_stat_search` int(10) unsigned NOT NULL auto_increment,
  `id_dict` int(10) unsigned NOT NULL default '0',
  `id_field` smallint(3) NOT NULL default '-1',
  `found` smallint(3) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `ip_long` int(10) unsigned NOT NULL default '0',
  `q` blob,
  PRIMARY KEY  (`id_stat_search`),
  KEY `date_created` (`date_created`),
  KEY `id_dict` (`id_dict`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=1 DELAY_KEY_WRITE=1;




DROP TABLE IF EXISTS `{PREFIX}theme`;
CREATE TABLE `{PREFIX}theme` (
  `id_theme` varchar(128) NOT NULL default '',
  `is_active` enum('0','1') NOT NULL default '1',
  `v1` tinyint(1) unsigned NOT NULL default '1',
  `v2` tinyint(1) unsigned NOT NULL default '0',
  `v3` tinyint(1) unsigned NOT NULL default '0',
  `theme_name` varbinary(128) NOT NULL default '',
  `theme_author` varbinary(128) NOT NULL default '',
  `theme_email` varchar(128) NOT NULL default '',
  `theme_url` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id_theme`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}theme_group`;
CREATE TABLE `{PREFIX}theme_group` (
  `settings_key` varchar(128) NOT NULL default '',
  `id_group` tinyint(3) unsigned NOT NULL default '0',
  `int_sort` mediumint(5) unsigned NOT NULL default '0',
  KEY `settings_key` (`settings_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}theme_settings`;
CREATE TABLE `{PREFIX}theme_settings` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_theme` varchar(128) NOT NULL default '',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_compiled` int(10) NOT NULL default '0',
  `settings_key` varchar(128) NOT NULL default '',
  `settings_value` blob NOT NULL,
  `code` blob NOT NULL,
  `code_i` blob NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_theme` (`id_theme`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}toolbar`;
CREATE TABLE `{PREFIX}toolbar` (
  `id` mediumint(5) unsigned NOT NULL auto_increment,
  `int_sort` smallint(3) unsigned NOT NULL default '0',
  `character` varbinary(4) NOT NULL default '',
  `id_lang` varchar(9) NOT NULL default 'en-utf8',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}topics`;
CREATE TABLE `{PREFIX}topics` (
  `id_topic` tinyint(3) unsigned NOT NULL auto_increment,
  `is_active` enum('0','1') NOT NULL default '1',
  `int_sort` tinyint(3) NOT NULL default '10',
  `id_parent` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `topic_icon` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`id_topic`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}topics_phrase`;
CREATE TABLE `{PREFIX}topics_phrase` (
  `id_topic_phrase` mediumint(5) unsigned NOT NULL auto_increment,
  `id_topic` tinyint(3) unsigned NOT NULL default '0',
  `id_lang` varchar(10) NOT NULL default 'en-utf8',
  `topic_title` varbinary(255) NOT NULL default '',
  `topic_descr` mediumblob NOT NULL,
  PRIMARY KEY  (`id_topic_phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}users`;
CREATE TABLE `{PREFIX}users` (
  `id_user` smallint(5) unsigned NOT NULL auto_increment,
  `date_reg` int(10) unsigned NOT NULL default '0',
  `date_login` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '0',
  `user_actkey` varchar(16) NOT NULL default '',
  `perm_level` tinyint(3) unsigned NOT NULL default '4',
  `user_name` varbinary(64) NOT NULL default '',
  `user_email` varchar(64) NOT NULL default '',
  `is_showcontact` enum('0','1') NOT NULL default '0',
  `int_terms` int(10) unsigned NOT NULL default '0',
  `user_settings` blob NOT NULL,
  PRIMARY KEY  (`id_user`),
  UNIQUE KEY `user_email` (`user_email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}wordlist`;
CREATE TABLE `{PREFIX}wordlist` (
  `word_text` varbinary(100) NOT NULL default '',
  `word_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`word_text`),
  UNIQUE KEY `word_id` (`word_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS `{PREFIX}wordmap`;
CREATE TABLE `{PREFIX}wordmap` (
  `word_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` smallint(5) unsigned NOT NULL default '0',
  `term_match` tinyint(2) NOT NULL default '0',
  KEY `word_id` (`word_id`),
  KEY `term_id` (`term_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
