<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: a.import.inc.php 84 2007-06-19 13:01:21Z yrtimd $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *  © 2002-2007 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
	Import. External utility for a dictionary.
	<line>
		<term t1="T" t2="TE" t3="TE" is_active="1" is_complete="1" id="1">term</term>
		<defn>
			<trsp><![CDATA[trsp]]></trsp>
			<abbr><![CDATA[abbr]]></abbr>
			<trns><![CDATA[trns]]></trns>
				<![CDATA[defn]]>
			<usg><![CDATA[usg]]></usg>
			<syn><![CDATA[syn]]></syn>
			<antonym><![CDATA[antonym]]></antonym>
			<see><![CDATA[see]]></see>
			<src><![CDATA[src]]></src>
			<address><![CDATA[address]]></address>
			<phone><![CDATA[phone]]></phone>
		</defn>
	</line>
	@version $Id: a.import.inc.php 84 2007-06-19 13:01:21Z yrtimd $
 */
// --------------------------------------------------------

/* */
function text_parse_csv_column_input($t)
{
	$t = str_replace("'", '&#39;', $t);
	$t = str_replace(' "', ' &#34;', $t);
	$t = str_replace('& ', '&amp; ', $t);
	$t = preg_replace('/[^\\\\]\\\n/', "\n", $t);
	$t = preg_replace('/[^\\\\]\\\t/', "\t", $t);
	$t = str_replace('\\\n', '\n', $t);
	$t = str_replace('\\\r', '\r', $t);
	$t = str_replace('\\\t', '\t', $t);
	return $t;
}
/**
 *
 */
function gw_import_xml()
{
	global $oSess, $oDb, $oCase, $oSqlQ, $oFunc;
	global $arPost, $sys, $arReq, $arFields, $vars, $arBroken, $gw_this, $arDictParam;
	global $int_added_terms, $file_location, $strR, $arStatus, $xml_file, $int_size_b;
	/* Save user settings */
	$oSess->user_set('import_is_validate', $arPost['is_validate']);
	/* Skip fields checking */
	/* ... */
	/* */
	$arPost['xml'] =& $gw_this['vars']['arPost']['xml'];
	/* Uploaded file, 0.040277 */
	$xml_file = isset($file_location['tmp_name']) ? $file_location['tmp_name'] : '';
	if (is_uploaded_file($xml_file)
		&& move_uploaded_file($xml_file, $sys['path_temporary'].'/'.urlencode($file_location['name']))
		)
	{
		$arPost['xml'] = $oFunc->file_get_contents($sys['path_temporary'].'/'.urlencode($file_location['name']));
		unlink($sys['path_temporary'].'/'.urlencode($file_location['name']));
	}
	/* Fix header if there are single <line>'s only */
	if (preg_match("/^([\s])*<line/", $arPost['xml']))
	{
		$arPost['xml'] = '<?xml version="1.0" encoding="'.$sys['internal_encoding'].'"?>' .
						 '<glossword>' . CRLF . $arPost['xml'] . '</glossword>';
	}
	$int_size_b = strlen($arPost['xml']);
	/* XML-syntax check */
	$isPostError = 0;
	if ($arPost['is_validate'] && function_exists('xslt_create'))
	{
		include_once( $sys['path_include']. '/class.xmlparse.php' );
		$xml_parser =& new xmlTinyParser();
		$is_return = $xml_parser->parse($arPost['xml']);
		if (!$is_return)
		{
			// Uploaded file can be too big,
			// so we do not need to put file contents into HTML-form,
			// show filename instead
			if (file_exists($xml_file) && is_uploaded_file($xml_file))
			{
				$arPost['xml'] = $file_location['name'];
			}
			$arBroken['xml'] = $isPostError = 1;
		}
	}
	if ($isPostError)
	{
		/* Call HTML-form again */
		$arPost['file_location'] = '';
		$arPost['csv'] = '';
		$arPost['xml'] = '';
		$strR .= getFormImport($arPost, 1, $arBroken, $arReq[$gw_this['vars'][GW_TARGET]]);
		$strR .= '<br />';
		return;
	}
	/* ... */
	/* Escape sequences */
	if ($arPost['is_convert_esc'])
	{
		$ar_esc = array('\r\n' => "\r\n", '\n' => "\n", '\r' => "\r", '\t' => "\t");
		$arPost['xml'] = str_replace(array_keys($ar_esc), array_values($ar_esc), $arPost['xml']);
	}
	/* Whitespace characters */
	if (!$arPost['is_whitespace'])
	{
		$arPost['xml'] = preg_replace("/(\r\n|\r|\n|\t)/", ' ', $arPost['xml']);
	}
	$cnt = 0;
	$queryA = array();
	/* Create array with raw XML data to insert into database, per <line> */
	$ar_lines_raw = explode("<line>", $arPost['xml']);
	unset($ar_lines_raw[0]);
	/* Get stopwords */
	$arStop = array();
	if ($arDictParam['is_filter_stopwords'])
	{
		$arStop = gw_get_stopwords($arDictParam);
	}
	/* convert old formats */
	if (!preg_match('/\]\]></', $arPost['xml']))
	{
#		$arPost['xml'] = str_replace('<defn>', '<defn><![CDATA[', str_replace('</defn>', ']]></defn>', $arPost['xml']));
		$arPost['xml'] = str_replace('<trsp>', '<trsp><![CDATA[', str_replace('</trsp>', ']]></trsp>', $arPost['xml']));
		$arPost['xml'] = preg_replace('/<abbr(.*?)>/', '<abbr\\1><![CDATA[', str_replace('</abbr>', ']]></abbr>', $arPost['xml']));
		$arPost['xml'] = preg_replace('/<trns(.*?)>/', '<trns\\1><![CDATA[', str_replace('</trns>', ']]></trns>', $arPost['xml']));
		$arPost['xml'] = str_replace('<usg>', '<usg><![CDATA[', str_replace('</usg>', ']]></usg>', $arPost['xml']));
		$arPost['xml'] = preg_replace('/<see(.*?)>/', '<see\\1><![CDATA[', str_replace('</see>', ']]></see>', $arPost['xml']));
		$arPost['xml'] = preg_replace('/<syn(.*?)>/', '<syn\\1><![CDATA[', str_replace('</syn>', ']]></syn>', $arPost['xml']));
		$arPost['xml'] = str_replace('<src>', '<src><![CDATA[', str_replace('</src>', ']]></src>', $arPost['xml']));
		$arPost['xml'] = str_replace('<![CDATA[<![CDATA[', '<![CDATA[', $arPost['xml']);
		$arPost['xml'] = str_replace(']]>]]>', ']]>', $arPost['xml']);
	}
	/* Enter debug mode. None of `INSERT' or `DELETE' queries will be executed. */
#	$sys['isDebugQ'] = 1;

	$arStatus = array();
	/* Do import using DOM model */
	$oDom = new gw_domxml;
	$oDom->is_skip_white = 0;
	$oDom->strData =& $arPost['xml'];
	$oDom->parse();
	$arXmlLine = $oDom->get_elements_by_tagname('line');

	if (empty($arXmlLine))
	{
		$arBroken['xml'] = 1;
		$arPost['file_location'] = '';
		$arPost['csv'] = '';
		$arPost['xml'] = '';
		/* Call HTML-form again */
		$strR .= getFormImport($arPost, 1, $arBroken, $arReq[$gw_this['vars'][GW_TARGET]]);
		$strR .= '<br />';
		return;
	}
	$oDom->strData = '';
	/* For each <line> */
#	$oT = new gw_timer('tt');
	for (reset($arXmlLine); list($k1, $v1) = each($arXmlLine);)
	{
		$qT = array();
		$arTermMap = array();
		$arQ = array();
		$id_term = 0;
		$id_term_old = 0;
		$is_clean_map = 0;
		$is_term_exists = 0;
		$ar_keywords_raw = array();
		$ar_keywords = array();
		if (!isset($v1['children'])) { continue; }
		for (reset($v1['children']); list($k2, $v2) = each($v1['children']);)
		{
			if (!is_array($v2)){ continue; }
			switch ($v2['tag'])
			{
				case 'term':
					/* 22 jul 2003, 26 june 2005: Custom Term ID */
					$qT['id'] = $oDom->get_attribute('id', $v2['tag'], $v2);
					$qT['id'] = preg_replace("/[^0-9]/", '', trim($qT['id']));
					$id_term_db = $oDb->MaxId($arDictParam['tablename'], 'id');
					/* 21 jul 2003: Better protection by using random number for Next ID */
					$qT['id'] = ($qT['id'] == '') ? mt_rand($id_term_db, ($sys['leech_factor']) + $id_term_db) : $qT['id'];
					$term_value = $oDom->get_content($v2);
					$qT['date_modified'] = $oDom->get_attribute('date_modified', $v2['tag'], $v2);
					$qT['date_modified'] = ($qT['date_modified'] == '') ? mktime() - ($sys['gmt_offset'] * 60 * 60) : $qT['date_modified'];
					$qT['date_created'] = $oDom->get_attribute('date_created', $v2['tag'], $v2);
					$qT['date_created'] = ($qT['date_created'] == '') ? mktime() - ($sys['gmt_offset'] * 60 * 60) : $qT['date_created'];
					$qT['term_3'] = $oDom->get_attribute('t3', $v2['tag'], $v2);
					$qT['term_2'] = $oDom->get_attribute('t2', $v2['tag'], $v2);
					$qT['term_1'] = $oDom->get_attribute('t1', $v2['tag'], $v2);
					$qT['is_active'] = $oDom->get_attribute('is_active', $v2['tag'], $v2);
					$qT['is_complete'] = $oDom->get_attribute('is_complete', $v2['tag'], $v2);
					$str_term_filtered = text_normalize($term_value);
					$ar_keywords[1] = text2keywords( $str_term_filtered, $arDictParam['min_srch_length'], 25, $sys['internal_encoding'] );
					if ($arPost['is_check_exist'])
					{
						/* Strict search for an existent term including special chars */
						if ($arPost['is_specialchars'])
						{
							$ar_chars_sql = array('\\' => '\\\\', '\\%' => '\\\\\\\%', '\\_' => '\\\\\\\_', '\\"' => '\\\\\\\"', "\\'" => "\\\\\\\'");
							$sql = $oSqlQ->getQ('get-term-exists-spec',
										$arDictParam['tablename'],
										str_replace(array_keys($ar_chars_sql), array_values($ar_chars_sql), gw_text_sql($term_value)),
										$qT['id']
							);
						}
						else
						{
							/* Search for an existent term by matched keywords */
							$sql_word_search = "k.word_text IN ('" . implode("', '", $ar_keywords[1]) . "')";
							$sql = $oSqlQ->getQ('get-term-exists', TBL_WORDLIST,
								$arDictParam['tablename'], $arDictParam['id'], 1, $sql_word_search
							);
						}
#						prn_r( $sql );
						$arSql = $oDb->sqlExec($sql);
						/* Compare founded values with imported values */
						for (; list($arK, $arV) = each($arSql);)
						{
							/* Imported Term ID and an existent Term ID are the same */
							if ($arV['id'] == $qT['id'])
							{
								/* Use old Term ID:
									1) to keep old links to a term
									2) to prevent SQL-table defragmentation
								*/
								$id_term_old = $arV['id'];
								$is_term_exists = 1;
								break;
							}
							/* Compare using keywords */
							$ar_kw_existent_term = text2keywords( $oCase->nc($arV['term']), 1, 25, $sys['internal_encoding'] );
							sort($ar_keywords[1]);
							sort($ar_kw_existent_term);
							/* Keywords from imported Term ID and from existent Term ID are the same */
							if (implode('', $ar_keywords[1]) == implode('', $ar_kw_existent_term))
							{
								$is_term_exists = 1;
								break;
							}
						} /* END for each matched keywords in a term */
					}
					if ($is_term_exists && $arPost['is_overwrite'])
					{
						$qT['id'] = $arV['id'];
						/* $id_term_old is used in gwAddNewKeywords() */
						$id_term_old = $arV['id'];
						$is_clean_map = 1;
						$is_term_exists = 0;
#						$arQ[] = $oSqlQ->getQ('del-term_id', $arDictParam['tablename'], $id_term_old, $arDictParam['id']);
					}
					$qT['term_3'] = ($qT['term_3'] == '') ? $oFunc->mb_substr($str_term_filtered, 0, 3) : $qT['term_3'];
					$qT['term_2'] = ($qT['term_2'] == '') ? $oFunc->mb_substr($qT['term_3'], 0, 2) : $qT['term_2'];
					$qT['term_1'] = ($qT['term_1'] == '') ? $oFunc->mb_substr($qT['term_2'], 0, 1) : $qT['term_1'];
					$qT['is_active'] = ($qT['is_active'] == '') ? 1 : $qT['is_active'];
					$qT['is_complete'] = ($qT['is_complete'] == '') ? 1 : $qT['is_complete'];
					$qT['term'] =& $term_value;
					/* Store definition contents (raw XML-data) */
					$qT['defn'] = $ar_lines_raw[$k1+1];
					$qT['defn'] = preg_replace("/<term(.*?)>(.*?)<\/term>/", '', $qT['defn']);
					$qT['defn'] = str_replace('</line>', '', $qT['defn']);
					$qT['defn'] = str_replace('</glossword>', '', $qT['defn']);
					$qT['defn'] = str_replace('<glossword>', '', $qT['defn']);
					$qT['defn'] = preg_replace("/<glossword(.*?)>/", '', $qT['defn']);
					$qT['defn'] = trim($qT['defn']);
					$qT['int_bytes'] = strlen($qT['defn']);
					/* Add relation `user to term' */
					if (!$is_term_exists)
					{
						$arTermMap['user_id'] = $oSess->id_user;
						$arTermMap['term_id'] = $qT['id'];
						$arTermMap['dict_id'] = $arDictParam['id'];
					}
				break;
				case 'defn':
					if (!isset($v2['children']))
					{
						$ar_keywords_raw[$v2['tag']][] = $v2['value'];
						continue;
					}
					for (reset($v2['children']); list($k3, $v3) = each($v2['children']);)
					{
						/* no contents for definition */
						if (!is_array($v3) && trim($v3) == '')
						{
							continue;
						}
						elseif (!is_array($v3))
						{
							$ar_keywords_raw[$v2['tag']][] = ' ' . $v3;
							continue;
						}
						/* for each tag */
						#prn_r( $v3, __LINE__ );
						$ar_keywords_raw[$v3['tag']][] = $v3['value'];
					}
				break;
			}
		}
		#prn_r( $ar_keywords_raw );
		for (reset($arFields); list($fK, $fV) = each($arFields);)
		{
			#$ar_keywords[$fK] = array();
			if (isset($ar_keywords_raw[$fV[0]]))
			{
				$str_keywords_raw = implode(' ', $ar_keywords_raw[$fV[0]]);
				$ar_keywords[$fK] = text2keywords( text_normalize($str_keywords_raw), $arDictParam['min_srch_length'], 25, $sys['internal_encoding'] );
				/* Remove stopwords from parsed strings only (others are empty) */
				$ar_keywords[$fK] = gw_array_exclude($ar_keywords[$fK], $arStop);
				unset($ar_keywords_raw[$fV[0]]);
				$str_keywords_raw = '';
			}
			if ($fK != 0)
			{
#				$ar_keywords[0] = gw_array_exclude( $ar_keywords[0], $ar_keywords[$fK]);
			}
		}
#		prn_r( $ar_keywords );
		unset($arXmlLine[$k1]);
		unset($ar_lines_raw[$k1+1]);
		if (!$is_term_exists)
		{
			$int_added_terms++;
			gwAddNewKeywords($arDictParam['id'], $qT['id'], $ar_keywords, $id_term_old, $is_clean_map);
			$arQ[] = gw_sql_replace($qT, $arDictParam['tablename'], 1);
			$arQ[] = gw_sql_replace($arTermMap, TBL_MAP_USER_TERM, 1);
		}
		if ($sys['isDebugQ'])
		{
			$arStatus = array_merge($arQ, $arStatus);
		}
		else
		{
			/* Post queries */
			for (reset($arQ); list($qk, $qv) = each($arQ);)
			{
				$oDb->sqlExec($qv);
			}
		}
#prn_r( $ar_keywords, 'ar_keywords' );
	} /* END for each line */
	#print $oT->endp('tt', __LINE__);

}


/* */
function gw_import_csv()
{
	global $oSess, $oDb, $oCase, $oSqlQ, $oFunc, $oL;
	global $arPost, $sys, $arReq, $arFields, $vars, $arBroken, $gw_this, $arDictParam;
	global $int_added_terms, $file_location, $strR, $arStatus, $xml_file, $int_size_b;

	$oSess->user_set('import_is_read_first', $arPost['is_read_first']);

	/* Uploaded file */
	$xml_file = isset($file_location['tmp_name']) ? $file_location['tmp_name'] : '';
	if (is_uploaded_file($xml_file)
		&& move_uploaded_file($xml_file, $sys['path_temporary'].'/'.urlencode($file_location['name']))
		)
	{
		$arPost['csv'] = $oFunc->file_get_contents($sys['path_temporary'].'/'.urlencode($file_location['name']));
		unlink($sys['path_temporary'].'/'.urlencode($file_location['name']));
	}
	/* Skip fields checking */
	/* ... */
	$arPost['str_separator'] = "\t";
	$arPost['str_separator_defn'] = ' ;; ';
	$arPost['str_enclosed'] = '';
	/* */
	$ar_lines_csv = explode(CRLF, $arPost['csv']);
	$int_fields = sizeof($arFields);
	$int_lines = sizeof($ar_lines_csv);
	$int_size_b = strlen($arPost['csv']);
	$arPost['csv'] = '';
	$int_max_lines = 2600;
	$is_continue = 1;
	/* no data */
	if ($ar_lines_csv[0] == '')
	{
		$ar_lines_csv = array();
		$arPost['csv'] = $oL->m('1255');
	}
	/* too many lines */
	if ($int_lines > $int_max_lines)
	{
		$is_continue = 0;
		$ar_lines_csv = array();
		$arPost['csv'] = sprintf($oL->m('1254'), $int_max_lines, $int_lines);
	}
	if (!$is_continue)
	{
		$arPost['xml'] = '';
		$arBroken['csv'] = 1;
		$arPost['file_location'] = '';
		/* Call HTML-form again */
		$strR .= getFormImport($arPost, 1, $arBroken, $arReq[$gw_this['vars'][GW_TARGET]]);
		$strR .= '<br />';
		return;
	}
	if (!$arPost['is_read_first'])
	{
		unset($ar_lines_csv[0]);
	}
	/**
		Two steps:
		1. convert inputed data into array with XML-code
		2. import XML-code
	**/
	$arXML = array();
	$arDuplicates = array();
	for (reset($ar_lines_csv); list($k1, $v1) = each($ar_lines_csv);)
	{
		/* id, term, ... */
		$ar_line_csv = explode($arPost['str_separator'], $v1);
		/* fix first line, `+4' = id, t1, t2, t3 */
		if (($k1 == 0) && sizeof($ar_line_csv) != ($int_fields+4))
		{
			$ar_line_csv = explode($arPost['str_separator'], "\t" . $v1);
		}
		/* skip empty terms */
		if (!isset($ar_line_csv[1])) { continue; }
		for (reset($arFields); list($fK, $fV) = each($arFields);)
		{
			if (!isset($ar_line_csv[$fV[5]+1]))
			{
				/* Fill empty fields */
				$ar_line_csv[$fV[5]+1] = '';
			}
			/* Parse CSV */
			switch($fV[0])
			{
				case 'term':
					$uid = sprintf("%u", crc32($ar_line_csv[$fV[5]]));
					if (!isset($arXML[$uid][$fK]))
					{
						$arXML[$uid][-1] = $ar_line_csv[0];
						$arXML[$uid][-2] = $ar_line_csv[2];
						$arXML[$uid][-3] = $ar_line_csv[3];
						$arXML[$uid][-4] = $ar_line_csv[4];
						$arXML[$uid][$fK] = $ar_line_csv[$fV[5]];
					}
					else
					{
						$arDuplicates[$uid][$k1][$fK] = $ar_line_csv[$fV[5]];
					}
				break;
				case 'defn':
					if (!isset($arXML[$uid][$fK]))
					{
						$arXML[$uid][$fK] = '<![CDATA['.$ar_line_csv[$fV[5]].']]>';
					}
					else
					{
						$arDuplicates[$uid][$k1][$fK] = '<![CDATA['.$ar_line_csv[$fV[5]].']]>';
					}
				break;
				case 'see':
				case 'syn':
				case 'antonym':
					$ar_values = explode($arPost['str_separator_defn'], @$ar_line_csv[$fV[5]]);
					for (reset($ar_values); list($kTag, $vTag) = each($ar_values);)
					{
						/* Skip empty values */
						if (trim($vTag) == ''){ continue; }
						/* Search for attributes */
						preg_match("/^\((.*?)\) /", $vTag, $ar_attr);
						$str_attr = '';
						if (isset($ar_attr[1]))
						{
							$vTag = str_replace($ar_attr[0], '', $vTag);
							/* is_link, [text]*/
							$ar_attr_v = explode(',', $ar_attr[1]);
							$str_attr .= isset($ar_attr_v[0]) ? ' link="'.$vTag.'"' : '';
							$str_attr .= isset($ar_attr_v[1]) ? ' text="'.trim($ar_attr_v[1]).'"' : '';
						}
						$ar_values[$kTag] = '<'.$fV[0].$str_attr.'><![CDATA['.$vTag.']]></'.$fV[0].'>';
					}
					if (!isset($arXML[$uid][$fK]))
					{
						$arXML[$uid][$fK] = implode('', $ar_values);
					}
					else
					{
						$arDuplicates[$uid][$k1][$fK] = implode('', $ar_values);
					}
				break;
				case 'trns':
				case 'abbr':
					$ar_trnsabbr = explode($arPost['str_separator_defn'], $ar_line_csv[$fV[5]]);
					for (reset($ar_trnsabbr); list($kTag, $vTag) = each($ar_trnsabbr);)
					{
						/* Skip empty values */
						if (trim($vTag) == ''){ continue; }
						/* Search for attributes */
						preg_match("/^\(([0-9]+)\) /", $vTag, $ar_attr);
						$str_attr = '';
						if (isset($ar_attr[1]))
						{
							$str_attr = ' lang="'.$ar_attr[1].'"';
							$vTag = str_replace($ar_attr[0], '', $vTag);
						}
						$ar_trnsabbr[$kTag] = '<'.$fV[0].$str_attr.'><![CDATA['.$vTag.']]></'.$fV[0].'>';
					}
					if (!isset($arXML[$uid][$fK]))
					{
						$arXML[$uid][$fK] = implode('', $ar_trnsabbr);
					}
					else
					{
						$arDuplicates[$uid][$k1][$fK] = implode('', $ar_trnsabbr);
					}
				break;
				case 'trsp';
				case 'usg':
				case 'src':
				case 'phone':
				case 'address':
					$ar_values = explode($arPost['str_separator_defn'], @$ar_line_csv[$fV[5]]);
					for (reset($ar_values); list($kTag, $vTag) = each($ar_values);)
					{
						/* Skip empty values */
						if (trim($vTag) == ''){ continue; }
						$ar_values[$kTag] = '<'.$fV[0].'><![CDATA['.$vTag.']]></'.$fV[0].'>';
					}
					if (!isset($arXML[$uid][$fK]))
					{
						$arXML[$uid][$fK] = implode('', $ar_values);
					}
					else
					{
						$arDuplicates[$uid][$k1][$fK] = implode('', $ar_values);
					}
				break;
			}
		} /* $arFields */
		unset($ar_lines_csv[$k1]);
	}
	/* Initiate $oCase class, 0.131938 */
	$oCase->nc('a');
#$sys['isDebugQ'] = 1;
	/* Strongly based on $arFields
		1. Create XML-code.
		2. Join primary and secondary definitions.
		3. Create keywords.
	*/
	/* Exclude stopwords */
	$arData = array();
	$arStop = gw_get_stopwords($arDictParam);
#	prn_r( $arXML );
	for (reset($arXML); list($uid, $v1) = each($arXML);)
	{
		/* Prepare keywords per field */
		for (reset($v1); list($id_field, $v2) = each($v1);)
		{
			if (!isset($arFields[$id_field])) { continue; }
			$fV =& $arFields[$id_field];
			$v2 = str_replace('<![CDATA[', '', $v2);
			$v2 = str_replace(']]>', '', $v2);
			/* Get maximum search length per field */
			$int_min_length = (isset($fV[2]) && ($fV[2] != 'auto') && ($fV[2] != '')) ? $fV[2] : $arDictParam['min_srch_length'];
			$ar_keywords[$uid][$id_field] = text2keywords( text_normalize($v2), $arDictParam['min_srch_length'], 25, $sys['internal_encoding'] );
			/* Remove stopwords from parsed strings only (others are empty) */
			$ar_keywords[$uid][$id_field] = gw_array_exclude( $ar_keywords[$uid][$id_field], $arStop);
			if (empty($ar_keywords[$uid][$id_field]))
			{
				unset($ar_keywords[$uid][$id_field]);
			}
		}
		$arData[$uid]['id'] = $v1[-1];
		$arData[$uid]['term'] = $v1[1];
		$arData[$uid]['term_1'] = $v1[-2];
		$arData[$uid]['term_2'] = $v1[-3];
		$arData[$uid]['term_3'] = $v1[-4];
		unset($v1[1]);
		unset($v1[-1]);
		unset($v1[-2]);
		unset($v1[-3]);
		unset($v1[-4]);
		$arData[$uid]['defn'] = '<defn>'.implode('', $v1).'</defn>';
		if (isset($arDuplicates[$uid]))
		{
			for (reset($arDuplicates[$uid]); list($kD, $arVd) = each($arDuplicates[$uid]);)
			{
				unset($arVd[1]);
				$arData[$uid]['defn'] .= '<defn>'.implode('', $arVd).'</defn>';
			}
		}
		unset($arXML[$uid]);
	}
#	prn_r( $ar_keywords );
	/* */
	/* For each <line> */
	for (reset($arData); list($uid, $v1) = each($arData);)
	{
		$qT = array();
		$arTermMap = array();
		$arQ = array();
		$id_term = 0;
		$id_term_old = 0;
		$is_clean_map = 0;
		$is_term_exists = 0;
		$qT['id'] = $v1['id'];
		if ($qT['id'] == '')
		{
			$id_term_db = $oDb->MaxId($arDictParam['tablename'], 'id');
			$qT['id'] = mt_rand($id_term_db, ($sys['leech_factor'] * 2) + $id_term_db);
		}
		$term_value =& $v1['term'];
		/* Set realtime */
		$qT['date_modified'] = $qT['date_created'] = mktime() - ($sys['gmt_offset'] * 60 * 60);
		$str_term_filtered = text_normalize($term_value);
		if ($arPost['is_check_exist'])
		{
			/* Strict search for an existent term including special chars */
			if ($arPost['is_specialchars'] || empty($ar_keywords[$uid][1]) )
			{
				$ar_chars_sql = array('\\' => '\\\\', '\\%' => '\\\\\\\%', '\\_' => '\\\\\\\_', '\\"' => '\\\\\\\"', "\\'" => "\\\\\\\'");
				$sql = $oSqlQ->getQ('get-term-exists-spec',
								$arDictParam['tablename'],
							str_replace(array_keys($ar_chars_sql), array_values($ar_chars_sql), gw_text_sql($term_value)),
							$qT['id']
				);
			}
			else
			{
				/* Search for an existent term by matched keywords */
				$sql_word_search = "k.word_text IN ('" . implode("', '", $ar_keywords[$uid][1]) . "')";
				$sql = $oSqlQ->getQ('get-term-exists', TBL_WORDLIST,
					$arDictParam['tablename'], $arDictParam['id'], 1, $sql_word_search
				);
			}
			$arSql = $oDb->sqlExec($sql);
			/* Compare founded values with imported values */
			for (; list($arK, $arV) = each($arSql);)
			{
				/* Imported Term ID and an existent Term ID are the same */
				if ($arV['id'] == $qT['id'])
				{
					$id_term_old = $arV['id'];
					$is_term_exists = 1;
					break;
				}
				$ar_kw_existent_term = text2keywords( $oCase->nc($arV['term']), 1, 25, $sys['internal_encoding'] );
				sort($ar_keywords[$uid][1]);
				sort($ar_kw_existent_term);
				if (implode('', $ar_keywords[$uid][1]) == implode('', $ar_kw_existent_term))
				{
					$is_term_exists = 1;
					break;
				}
			} /* end for each matched keywords for a term */
		}
		if ($is_term_exists && $arPost['is_overwrite'])
		{
			$qT['id'] = $arV['id'];
			$id_term_old = $arV['id'];
			$is_clean_map = 1;
			$is_term_exists = 0;
		}
		/* imported data may not have any alphabetic orders */
		$qT['term_3'] = ($v1['term_3'] == '') ? $oFunc->mb_substr($str_term_filtered, 0, 3) : $v1['term_3'];
		$qT['term_2'] = ($v1['term_2'] == '') ? $oFunc->mb_substr($qT['term_3'], 0, 2) : $v1['term_2'];
		$qT['term_1'] = ($v1['term_1'] == '') ? $oFunc->mb_substr($qT['term_2'], 0, 1) : $v1['term_1'];
		$qT['term'] =& $term_value;
		$qT['is_active'] = 1;
		$qT['is_complete'] = 1;

		/* Escape sequences */
		if ($arPost['is_convert_esc'])
		{
			$ar_esc = array('\r\n' => "\r\n", '\\n' => "\n", '\\r' => "\r", '\\t' => "\t");
			$v1['defn'] = str_replace(array_keys($ar_esc), array_values($ar_esc), $v1['defn']);
		}
		/* Whitespace characters */
		if ($arPost['is_whitespace'])
		{
			$v1['defn'] = preg_replace('/[^\\\](\\\r\\\n|\\\r|\\\n|\\\t)/', '\\\\' . "\\1", $v1['defn']);
		}
		$qT['defn'] = text_parse_csv_column_input($v1['defn']);
		$qT['int_bytes'] = strlen($qT['defn']);
		/* Add relation `user to term' */
		if (!$is_term_exists)
		{
			$arTermMap['user_id'] = $oSess->id_user;
			$arTermMap['term_id'] = $qT['id'];
			$arTermMap['dict_id'] = $arDictParam['id'];

			$int_added_terms++;
			gwAddNewKeywords($arDictParam['id'], $qT['id'], $ar_keywords[$uid], $id_term_old, $is_clean_map);
			$arQ[] = gw_sql_replace($qT, $arDictParam['tablename'], 1);
			$arQ[] = gw_sql_replace($arTermMap, TBL_MAP_USER_TERM, 1);
		}
		else
		{
			global $oL;
			$arStatus[] = $oL->m('reason_25').': ' . $qT['term'];
		}
		/* */
		if ($sys['isDebugQ'])
		{
			$arStatus = array_merge($arQ, $arStatus);
		}
		else
		{
			/* Post queries */
			for (reset($arQ); list($qk, $qv) = each($arQ);)
			{
				$oDb->sqlExec($qv);
			}
		}
		unset($ar_keywords[$uid]);
		unset($arData[$uid]);
	}
}
/* */
function getFormImport($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global ${GW_ACTION}, $id, $oL, $oSess, $arPost, $oFunc, $sys, $oCase;
	global $ar_theme, $gw_this;

	$strForm = '';
	$trClass = 'xt';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '20%';

	$oForm = new gwForms();
	$oForm->Set('action',          $sys['page_admin']);
	$oForm->Set('submitok',        $oL->m('3_save'));
	$oForm->Set('submitdel',       $oL->m('3_remove'));
	$oForm->Set('submitcancel',    $oL->m('3_cancel'));
	$oForm->Set('formbgcolor',     $ar_theme['color_2']);
	$oForm->Set('formbordercolor', $ar_theme['color_4']);
	$oForm->Set('formbordercolorL',$ar_theme['color_1']);
	$oForm->Set('align_buttons',   $GLOBALS['sys']['css_align_right']);
	$oForm->Set('charset', $sys['internal_encoding']);
	// Upload xml-file
	if ($sys['is_upload']) { $oForm->Set('enctype', 'multipart/form-data'); }
	## ----------------------------------------------------
	##
	 // check vars
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------
	$arBoxId = array();
	$strForm .= getFormTitleNav($oL->m('1061'));
	$strForm .= '<table class="gw2TableFieldset" width="100%"><tbody>';
	$strForm .= '<tr><td style="width:1%"></td><td></td></tr>';

	$arBoxId['id'] = 'arPost_format_xml';

	$arBoxId['onchange'] = 'checkFormat()';
	$strForm .= '<tr>'.
				 '<td class="td1">' . $oForm->field('radio', 'arPost[format]', 'xml', ($vars['format'] == 'xml'), $arBoxId ) . '</td>'.
				 '<td class="td2"><label for="arPost_format_xml">XML</label></td>'.
				'</tr>';
	$strForm .= '<tr>';
	$strForm .= '<td></td>';
	$strForm .= '<td>';

		$strForm .= '<div id="table_xml">';
		$strForm .= '<table class="gw2TableFieldset" width="100%" style="border:1px '.$ar_theme['color_4'].' solid"><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'" style="width:11%"></td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['xml'] . '<textarea '.
					' onfocus="if(typeof(document.layers)==\'undefined\'||typeof(ts)==\'undefined\'){ts=1;this.form.elements[\'arPost[\'+\'xml\'+\']\'].select();}"'.
					' style="width:100%;font:85% \'verdana\',arial,sans-serif"'.
					' name="arPost[xml]" id="arPost_xml_" dir="ltr" cols="45" rows="10">' . htmlspecialchars_ltgt($vars['xml']) . '</textarea>'.
					'</td>'.
					'</tr>';
		/* 3 mar 2003 */
		/* Allows to upload a file */
		if ($sys['is_upload'])
		{
			$oForm->setTag('file', 'id', 'file_location_xml');
			$oForm->setTag('file', 'dir', 'ltr');
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">&#160;</td>'.
						'<td class="'.$v_class_2.'">' . $oForm->field('file', 'file_location', $vars['file_location']) . '</td>'.
						'</tr>';
		}
		if (function_exists('xslt_create'))
		{
			$strForm .= '<tr>'.
						 '<td class="td1">' . $oForm->field('checkbox', "arPost[is_validate]", $vars['is_validate']) . '</td>'.
						 '<td class="td2"><label for="arPost_is_validate_">' . $oL->m('validate') . '</label></td>'.
						'</tr>';
		}
		$strForm .= '</tbody></table></div>';
	/* */
	$strForm .= '</td></tr>';

	$arBoxId['id'] = 'arPost_format_csv';
	$strForm .= '<tr>'.
				 '<td class="td1">' . $oForm->field('radio', 'arPost[format]', 'csv', ($vars['format'] == 'csv'), $arBoxId ) . '</td>'.
				 '<td class="td2"><label for="arPost_format_csv">CSV</label></td>'.
				'</tr>';
	$strForm .= '<tr>';
	$strForm .= '<td></td>';
	$strForm .= '<td>';

		$strForm .= '<div id="table_csv">';
		$strForm .= '<table class="gw2TableFieldset" width="100%" style="border:1px '.$ar_theme['color_4'].' solid"><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'" style="width:10%"></td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['csv'] . '<textarea '.
					' onfocus="if(typeof(document.layers)==\'undefined\'||typeof(ts)==\'undefined\'){ts=1;this.form.elements[\'arPost[\'+\'csv\'+\']\'].select();}"'.
					' style="width:100%;font:85% \'verdana\',arial,sans-serif"'.
					' name="arPost[csv]" id="arPost_csv_" dir="ltr" cols="45" rows="10">' . htmlspecialchars_ltgt($vars['csv']) . '</textarea>'.
					'</td>'.
					'</tr>';
		/* 3 mar 2003 */
		/* Allows to upload a file */
		if ($sys['is_upload'])
		{
			$oForm->setTag('file', 'id', 'file_location_csv');
			$oForm->setTag('file', 'dir', 'ltr');
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . '&#160;' . '' . $arReqMsg['file_location'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['file_location'] . $oForm->field('file', 'file_location', $vars['file_location']) . '</td>'.
						'</tr>';
		}
		$oForm->setTag('input', 'class', '');
		$oForm->setTag('input', 'size', '6');
		$oForm->setTag('input', 'maxlength', '5');
		$oForm->setTag('input', 'dir', 'ltr' );
#		$strForm .= '<tr>'.
#					'<td class="'.$v_class_1.'">' . $arBrokenMsg['str_separator'] . $oForm->field('input', 'arPost[str_separator]', htmlspecialchars($vars['str_separator'])) . '</td>'.
#					'<td class="'.$v_class_2.'">' . $oL->m('1119') . $arReqMsg['str_separator'] . '</td>'.
#					'</tr>';
#		$strForm .= '<tr>'.
#					'<td class="'.$v_class_1.'">' . $arBrokenMsg['str_enclosed'] . $oForm->field('input', 'arPost[str_enclosed]', htmlspecialchars($vars['str_enclosed'])) . '</td>'.
#					'<td class="'.$v_class_2.'">' . $oL->m('1120') . $arReqMsg['str_enclosed'] . '</td>'.
#					'</tr>';
#		$strForm .= '<tr>'.
#					'<td class="'.$v_class_1.'">' . $arBrokenMsg['str_separator_defn'] . $oForm->field('input', 'arPost[str_separator_defn]', htmlspecialchars($vars['str_separator_defn'])) . '</td>'.
#					'<td class="'.$v_class_2.'">' . $oL->m('1122') . $arReqMsg['str_separator_defn'] . '</td>'.
#					'</tr>';
		$strForm .= '<tr>'.
					 '<td class="td1">' . $oForm->field('checkbox', "arPost[is_read_first]", $vars['is_read_first']) . '</td>'.
					 '<td class="td2"><label for="arPost_is_read_first_">' . $oL->m('1123') . '</label></td>'.
					'</tr>';
		$strForm .= '</tbody></table>';

	$strForm .= '</td></tr></tbody>';
	$strForm .= '</table></div>';

	/* After posting... */
	$strForm .= getFormTitleNav($oL->m('options'));
	$tmp['after_post'] = $oSess->user_get('after_post_import');
	if (!$tmp['after_post'])
	{
		/* turn on "Import" option by default */
		$tmp['after_post'] = 4;
	}
	$tmp['ar_after_posting'] = array(
		4 => $oL->m('3_import'),
		1 => $oL->m('after_post_1'),
		3 => $oL->m('after_post_3')
	);
	$oForm->setTag('select', 'class',  'input50');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:15%"></td><td></td></tr>';

	$vars['is_overwrite'] = $oSess->user_get('import_is_overwrite') ? 1 : 0;
	$vars['is_specialchars'] = $oSess->user_get('import_is_specialchars') ? 1 : 0;
	$vars['is_whitespace'] = $oSess->user_get('import_is_whitespace') ? 1 : 0;
	$vars['is_convert_esc'] = $oSess->user_get('import_is_convert_esc') ? 1 : 0;

	$strForm .= '<tr>'.
				'<td class="td1">' . $oForm->field('checkbox', "arPost[is_check_exist]", $vars['is_check_exist']) . '</td>'.
				'<td class="td2"><label for="arPost_is_check_exist_">' . $oL->m('1139') . '</label></td>';
	$strForm .= '</tr>';

	$strForm .= '<tr>';
	$strForm .= '<td></td><td>';

		$strForm .= '<table border="0" class="gw2TableFieldset" width="100%"><tbody>';
		$strForm .= '<tr>'.
					'<td class="td1">' . $oForm->field('checkbox', "arPost[is_specialchars]", $vars['is_specialchars']) . '</td>'.
					'<td class="td2"><label for="arPost_is_specialchars_">' . $oL->m('is_specialchars') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="td1">' . $oForm->field('checkbox', "arPost[is_overwrite]", $vars['is_overwrite']) . '</td>'.
					'<td class="td2"><label for="arPost_is_overwrite_">' . $oL->m('overwrite') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr><td style="width:1%"></td><td></td></tr>';
		$strForm .= '</tbody></table>';


	$strForm .= '</td>'.
				'</tr>';

	$strForm .= '<tr>'.
				'<td class="td1">' . $oForm->field('checkbox', "arPost[is_whitespace]", $vars['is_whitespace']) . '</td>'.
				'<td class="td2"><label for="arPost_is_whitespace_">' . $oL->m('1039') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $oForm->field('checkbox', "arPost[is_convert_esc]", $vars['is_convert_esc']) . '</td>'.
				'<td class="td2"><label for="arPost_is_convert_esc_">' . $oL->m('1040') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $oL->m('after_post') . '</td>'.
				'<td class="td2">' . $oForm->field('select', 'arPost[after]', $tmp['after_post'], '', $tmp['ar_after_posting']).
				'</td>'.
				'</tr>';
	$strForm .= '</table>';

	include($sys['path_include'] . '/a.import.js.php');

	$strForm .= $oForm->field("hidden", 'id', $id);
	$strForm .= $oForm->field("hidden", GW_TARGET, GW_T_DICT);
	$strForm .= $oForm->field("hidden", GW_ACTION, GW_A_IMPORT);
	$strForm .= $oForm->field("hidden", GW_SID, $gw_this['vars'][GW_SID]);

	if ($arPost[GW_ACTION] == GW_A_ADD)
	{
		$strForm .= $oForm->field("hidden", 'arPost['.GW_ACTION.']', GW_A_ADD);
	}
	else
	{
		$strForm .= $oForm->field("hidden", 'arPost['.GW_ACTION.']', GW_A_UPDATE);
	}
	return $oForm->Output($strForm);
} // end of getFormImport()
// --------------------------------------------------------
// Prepare variables
if ($arPost == '') { $arPost = array(); }
if (!isset($arPost[GW_ACTION])) { $arPost[GW_ACTION] = GW_A_ADD; }
$vars['file_location'] = $file_location;
$arReq['dict'] = array('xml');

switch ($arPost[GW_ACTION])
{
	case GW_A_ADD:
## --------------------------------------------------------
## Show HTML-form
	/* Check permission */
	if (!isset($id) || (!$oSess->is('dict_edit')) )
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	if ($post == '')
	{
		/* Not saved */
		$cntFiles = 1;
		$vars['xml'] = '';
		$vars['csv'] = '';
		$vars['format'] = $oSess->user_get('import_format');
		$vars['is_overwrite'] = $oSess->user_get('import_is_overwrite') ? 1 : 0;
		$vars['is_validate'] = $oSess->user_get('import_is_validate') ? 1 : 0;
		$vars['is_read_first'] = $oSess->user_get('import_is_read_first') ? 1 : 0;
		$vars['is_check_exist'] = $oSess->user_get('import_is_check_exist') ? 1 : 0;
		$vars['is_convert_esc'] = $oSess->user_get('import_is_convert_esc') ? 1 : 0;
		$vars['is_whitespace'] = $oSess->user_get('import_is_whitespace') ? 1 : 0;
		if ($vars['format'] == '') { $vars['format'] = 'csv'; }

		$strR .= getFormImport($vars, 0, 0, $arReq[$t]);
		$arHelpMap['XML'] = htmlspecialchars_ltgt('<line><term t1="T" t2="TE" is_active="1" id="1">term</term><defn><trsp><![CDATA[trsp]]></trsp> <abbr><![CDATA[abbr]]></abbr> <trns><![CDATA[trns]]></trns><![CDATA[defn]]> <usg><![CDATA[usg]]></usg> <syn><![CDATA[syn]]></syn> <antonym><![CDATA[antonym]]></antonym> <see><![CDATA[see]]></see> <src><![CDATA[src]]></src> <address><![CDATA[address]]></address> <phone><![CDATA[phone]]></phone></defn></line>');
		if (function_exists('xslt_create'))
		{
			$arHelpMap['validate'] = 'tip011';
		}
		$arHelpMap['overwrite'] = 'tip012';
		$arHelpMap['is_specialchars'] = 'tip013';
		$arHelpMap['1039'] = 'tip026';
		$arHelpMap['1040'] = 'tip027';

		$strHelp = '';
		$strHelp .= '<dl>';
		for (; list($k, $v) = each($arHelpMap);)
		{
			$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
			$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
		}
		$strHelp .= '</dl>';
		$strR .= '<br />' . kTbHelp($oL->m('2_tip'), $strHelp);
	}
	else
	{
		$arStatus = array();
		$xml_file = '';
		$cnt = $int_added_terms = 0;
		/* Start import */
		@set_time_limit(3600);
		/* Unpack keys, set delay for key write (See MySQL Manual 5.2.12)*/
#		$oDb->sqlExec('ALTER TABLE `'. TBL_WORDLIST .'` PACK_KEYS=0 CHECKSUM=0 DELAY_KEY_WRITE=1');
#		$oDb->sqlExec('ALTER TABLE `'. TBL_WORDMAP .'` PACK_KEYS=0 CHECKSUM=0 DELAY_KEY_WRITE=1');
#		$oDb->sqlExec('ALTER TABLE `'. $arDictParam['tablename'] .'` PACK_KEYS=0 CHECKSUM=0 DELAY_KEY_WRITE=1');
		/* Start timer */
		$oTimer = new gw_timer('import');
		/* Fix on/off options */
		$arIsV = array('is_validate', 'is_overwrite', 'is_specialchars', 'is_whitespace',
						'is_convert_esc', 'is_read_first', 'is_check_exist');
		for (; list($k, $v) = each($arIsV);)
		{
			$arPost[$v] = isset($arPost[$v]) ? $arPost[$v] : 0;
		}
		$oSess->user_set('import_format', $arPost['format']);
		$oSess->user_set('import_is_check_exist', $arPost['is_check_exist']);
		$oSess->user_set('import_is_overwrite', $arPost['is_overwrite']);
		$oSess->user_set('import_is_specialchars', $arPost['is_specialchars']);
		$oSess->user_set('import_is_whitespace', $arPost['is_whitespace']);
		$oSess->user_set('import_is_convert_esc', $arPost['is_convert_esc']);
		/* Switch formats */
		switch($arPost['format'])
		{
			case 'xml':
				gw_import_xml();
			break;
			case 'csv':
				gw_import_csv();
			break;
		}
		/* Clean search results for edited dictionary */
		$arQ[] = $oSqlQ->getQ('del-srch-by-dict', $arDictParam['id']);
		/* Clear dictionary cache (hidden) */
		gw_tmp_clear($arDictParam['id']);
		/* Show time usage */
		$strR .= '<table cellpadding="2" cellspacing="1" width="100%" border="0"><tbody>';
		if (@ini_get('max_execution_time'))
		{
			$strR .= '<tr class="xt"><td>max_execution_time:</td><td><b>' . @ini_get('max_execution_time') . '</b> sec.</td></tr>';
		}
		$strR .= '<tr class="xt"><td style="width:25%">php_running_time:</td>';
		$strR .= '<td style="width:75%"><b>' . sprintf("%1.5f", $oTimer->end('import')) . '</b> sec.</td></tr>';
		if (($xml_file != '') && ($xml_file != 'none'))
		{
			$strR .= '<tr class="xt"><td>local_file:</td><td><b>' . $xml_file. '</b></td></tr>';
			$strR .= '<tr class="xt"><td>uploaded_file:</td><td><b>' . $file_location['name'] . '</b></td></tr>';
			$strR .= '<tr class="xt"><td>'. sprintf("%s:</td><td><b>%s</b> %s</td></tr>", $oL->m('size'), $oFunc->number_format($file_location['size'], 0, $oL->languagelist('4')), $oL->m('bytes'));
		}
		else
		{
			$strR .= '<tr class="xt"><td>'. sprintf("%s:</td><td><b>%1.2f</b> %s</td></tr>", $oL->m('size'), $int_size_b/1024, $oL->m('kb') );
		}
		$intAddedTerms = $cnt;
		$strR .= '<tr class="xt"><td>'. sprintf("%s:</td><td><b>%s</b></td></tr>", $oL->m('str_on_page'), $int_added_terms);
		$strR .= '<tr class="xt"><td>'. sprintf("%s:</td><td><b>%s</b> %s</td></tr>", $oL->m('1149'), sprintf("%1.1f", $int_added_terms/$oTimer->end('import')), $oL->m('1150') );

		$strR .= '</tbody></table>';
		$strR .= '<ul class="sql">';
		for (reset($arStatus); list($k, $v) = each($arStatus);)
		{
			$v = preg_replace("/[\r\n|\r|\n|\t]/", " ", $v);
			$v = $oFunc->mb_wordwrap($v, 70, CRLF, 1);
			$v = htmlspecialchars_ltgt($v);
			$strR .= '<li>'.$v.'</li>';
		}
		$strR .= '</ul>';
		/* */
		$oDb->sqlExec('CHECK TABLE `'. $arDictParam['tablename'] .'`');
#		$oDb->sqlExec('OPTIMIZE TABLE `'. $arDictParam['tablename'] .'`');
		/* Redirect to... */
		$str_url = gw_after_redirect_url($arPost['after']);
		$strR .= postQuery($arQ, $str_url, $sys['isDebugQ'], 1);
		return;
		#print $ot->endp(__LINE__, __FILE__);
		$arQ = array();
	}
##
## --------------------------------------------------------
break;
default:
break;
}

/* End of file */
?>