<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: func.sql.inc.php 84 2007-06-19 13:01:21Z yrtimd $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *   Functions to handle numerios SQL-requests.
 */
// --------------------------------------------------------



/**
 * Adds or updates a term.
 * @param   array   $arPre Data in structured array
 * @param   int     $id_dict Dictionary id
 * @param   array   $arStop Stop words
 * @param   int     $in_term Do search in term or not
 * @param   int     $is_specialchars Is allow special characters in a term
 * @param   int     $is_overwrite Overwrite if already exist
 * @param   int     $intLine Line number, used for Import to report
 * @param   int     $isDelete Is always delete (all checks for existent term will be skipped)
 */
function gwAddTerm($arPre, $id_dict, $arStop, $in_term, $is_specialchars, $is_overwrite, $intLine = 0, $isDelete = 0)
{
	global $oDom, $oFunc, $oDb, $oSqlQ, $oCase, $oL, $oHtml, $oSess;
	global $arFields, $arDictParam, $cnt, $tid, $sys;
	global $gw_this, $qT;

#	@header("content-type: text/html; charset=utf-8");

	$id_w = $oDb->MaxId($arDictParam['tablename']);
	$isQ = 1;
	$isCleanMap = 0;
	$id_old = isset($tid) ? $tid : 0;
	$queryA = $qT = array();
	$isTermExist = 0;
	$str_get_content = $oDom->get_content($arPre['term']);

	/* 22 jul 2003: Custom Term ID */
	$qT['id'] = $oDom->get_attribute('id', 'term', $arPre['term'] );
	$qT['id'] = preg_replace("/[^0-9]/", '', trim($qT['id']));
	/* */
	if (!$isDelete)
	{
		/** Check for an existed term */
		/* prepare keywords for a term */
		$strTermFiltered = $str_get_content;
		/* (empty) 0.000970 -> (old) 0.015592 -> (new v1.7.0) 0.002051 */
		if ($is_specialchars)
		{
			/* Keep specials */
#			$strTermFiltered = $oCase->rm_($strTermFiltered);
			$strTermFiltered = text_normalize($strTermFiltered);
			$strTermFiltered = gw_text_wildcars($strTermFiltered);
			$arKeywordsT = text2keywords($strTermFiltered, 1);
		}
		else
		{
			/* All specials */
			$strTermFiltered = text_normalize($strTermFiltered);
			$arKeywordsT = text2keywords($strTermFiltered, $arDictParam['min_srch_length']);
		}
		/* is there any keywords for a term? */
		$isTermEmpty = (empty($arKeywordsT) && (strlen(trim( $str_get_content )) == 0)) ? 1 : 0;
		if (!$isTermEmpty)
		{
			/* no empty keywords for a term */
			/* SQL-query */
			/* Get existent keywords, standard mode */
			$word_srch_sql = ($qT['id'] != '') ? 't.id = "' . $qT['id'] . '"' : '';
			if ($word_srch_sql == '')
			{
				$word_srch_sql = "k.word_text IN ('" . implode("', '", $arKeywordsT) . "')";
			}
			$sql = $oSqlQ->getQ('get-term-exists', TBL_WORDLIST, $arDictParam['tablename'], $id_dict,
						$in_term, $word_srch_sql
					);
			/* Get existent keywords, keep specialchars mode */
			if (($is_specialchars) || empty($arKeywordsT))
			{
				$ar_chars_sql = array('\\' => '\\\\', '\\%' => '\\\\\\\%', '\\_' => '\\\\\\\_', '\\"' => '\\\\\\\"', "\\'" => "\\\\\\\'");
				$sql = $oSqlQ->getQ('get-term-exists-spec', $arDictParam['tablename'],
						str_replace(array_keys($ar_chars_sql), array_values($ar_chars_sql), gw_addslashes( $str_get_content ))
					);
			}
			$arSql = $oDb->sqlExec($sql);
#			prn_r($arSql, __LINE__ . '<br />' . $sql);
			$isTermNotMatched = 1; // `No term found' by default

			for (; list($arK, $arV) = each($arSql);) // compare founded values (Q) with imported (T)
			{
				$id_old = $arV['id']; // get ID for existent keywords.
				if ($id_old == $qT['id'])
				{
					$isTermNotMatched = 0;
					break;
				}
				if ($is_specialchars)
				{
					/* 1 - is the minimum length */
					$arKeywordsQ = text2keywords( text_normalize($arV['term']), 1);
				}
				else
				{
					/* $arDictParam['min_srch_length'] - is the minimum length */
					$arKeywordsQ = text2keywords( text_normalize($arV['term']), $arDictParam['min_srch_length']);
				}
#				prn_r($arKeywordsQ);
				$div1 = sizeof(gw_array_exclude($arKeywordsT, $arKeywordsQ));
				$div2 = sizeof(gw_array_exclude($arKeywordsQ, $arKeywordsT));
				$isTermNotMatched = ($div1 + $div2);
				// if the sum of excluded arrays is 0, this term already exists
				if (!$isTermNotMatched) // in english, double negative means positive... yeah
				{
					break;
				}
			} // end of for each founded terms
			if ($isTermNotMatched > 0)
			{
				$isQ = 1;
				$isTermExist = 0;
			}
			else
			{
				$isTermExist = 1;
			}
		} // !$isTermEmpty
	}
	/* */
	if (!isset($strTermFiltered))
	{
		$strTermFiltered = gw_text_wildcars($str_get_content);
		$strTermFiltered = text_normalize($strTermFiltered);
	}
	/* 21 jan 2006: new `date_created' for new terms */
	$qT['date_created'] = isset($arPre['date_created']) ? $arPre['date_created'] : $sys['time_now_gmt_unix'];
	$qT['date_modified'] = $sys['time_now_gmt_unix'];
	/* 21 jul 2003: Better protection by adding random Next ID number */
	$qT['id']        = ($qT['id'] == '') ? mt_rand($id_w, ($sys['leech_factor'] * 2) + $id_w) : $qT['id'];
	$qT['term_3']    = $oDom->get_attribute('t3', 'term', $arPre['term'] );
	$qT['term_2']    = $oDom->get_attribute('t2', 'term', $arPre['term'] );
	$qT['term_1']    = $oDom->get_attribute('t1', 'term', $arPre['term'] );
	$qT['is_active'] = $oDom->get_attribute('is_active', 'term', $arPre['term']);
	$qT['is_complete'] = $oDom->get_attribute('is_complete', 'term', $arPre['term']);
	$qT['term_3']    = ($qT['term_3'] == '') ? $oFunc->mb_substr(str_replace('/', '', $strTermFiltered), 0, 3, $sys['internal_encoding']) : str_replace('/', '', $qT['term_3']);
	$qT['term_2']    = ($qT['term_2'] == '') ? $oFunc->mb_substr($qT['term_3'], 0, 2, $sys['internal_encoding']) : $qT['term_2'];
	$qT['term_1']    = ($qT['term_1'] == '') ? $oFunc->mb_substr($qT['term_2'], 0, 1, $sys['internal_encoding']) : $qT['term_1'];
	$qT['term']      =& $str_get_content;
	$qT['defn']      =& $arPre['parameters']['xml'];
 #   prn_r($arParsed);
 #   prn_r($qT, __LINE__);
#    exit;
	if ($isDelete || $isTermExist)
	{
		if ($is_overwrite)
		{
			$qT['id'] = $id_old;
			$isCleanMap = 1;
			$isTermExist = 0;
			$queryA[] = $oSqlQ->getQ('del-term_id', $arDictParam['tablename'], $id_old, $id_dict);
		}
	}
	if (!$isDelete && $isTermExist)
	{
		$ar_matched_terms = array();
		for (reset($arSql); list($arK, $arV) = each($arSql);)
		{
			$ar_matched_terms[]  = $oHtml->a($sys['page_admin'].'?'.GW_ACTION.'='.GW_A_EDIT.'&'.GW_TARGET.'=' . GW_T_TERM.'&id='.$id_dict.'&tid=' . $arV['id'],
						 $arV['term'], '', '', $oL->m('3_edit'));
		}
		$str_line = implode(' | ', $ar_matched_terms);
		$queryA = '<dl style="margin:0">';
		$queryA .= '<dt class="xu red">'.$oL->m('reason_25').' - <b>'. $str_get_content . '</b></dt>';
		$queryA .= '<dd>'.$str_line. '</dd>';
		$queryA .= '</dl>';
		$isQ = 0;
	}
	/* Allow query */
	if ($isQ)
	{
		/* Prepare keywords per field */
#		$ot = new gw_timer('addterm');
		for (reset($arFields); list($fK, $fV) = each($arFields);)
		{
			// Init
			$arKeywords[$fK] = array();
			//
			// Get maximum search length per field
			$int_min_length = (isset($fV[2]) && ($fV[2] != 'auto') && ($fV[2] != '')) ? $fV[2] : $arDictParam['min_srch_length'];
			//
			// Make keywords from array
			// space is required, otherwise `...word</defn><defn>word...' will become `wordword'
			$tmpStr = '';
			if (isset($arPre[$fV[0]]))
			{
				$tmpStr = $oDom->get_content( $arPre[$fV[0]] );
			}
			if ($tmpStr != '') // do not parse empty strings
			{
#				$isStrip = ($srchLength == 1) ? 0 : 1;
#                prn_r( text_normalize( $tmpStr ) . ' ' . $fV[0] . '; len=' . $int_min_length);
				/* Fix wildcars, 1.6.1 */
				$tmpStr = str_replace('<![CDATA[', '', $tmpStr);
				$tmpStr = str_replace(']]>', '', $tmpStr);
				$tmpStr = gw_text_wildcars($tmpStr);
				/* */
				$arKeywords[$fK] = text2keywords( gw_text_sql(text_normalize($tmpStr)), $int_min_length, 25, $sys['internal_encoding'] );
				/* Remove stopwords from parsed strings only (others are empty) */
				$arKeywords[$fK] = gw_array_exclude( $arKeywords[$fK], $arStop);
			}
		}
		/* keywords convertion time */
#		prn_r( $arKeywords );
#		print $ot->endp(__LINE__, __FILE__);
#		exit;
		/* Remove double keywords from definition */
		for (reset($arFields); list($fK, $fV) = each($arFields);)
		{
			if ($fK != 0)
			{
				$arKeywords[0] = gw_array_exclude( $arKeywords[0], $arKeywords[$fK]);
			}
		}
		/** Keywords were prepared */
		/** Add keywords to database! Now! */
#       prn_r($arStop);
#       prn_r($arKeywords);
#       prn_r($arPre);
		gwAddNewKeywords($id_dict, $qT['id'], $arKeywords, $id_old, $isCleanMap);
		/* Do automatic corrections for HTML */
		$qT['term'] = gw_htmlentities($qT['term']);
		$qT['defn'] = gw_htmlentities($qT['defn']);
		$qT['int_bytes'] = strlen($qT['defn']);
		$qT['crc32u'] = sprintf("%u", crc32($qT['id'].$qT['term'].$qT['term_1'].$qT['term_2'].$qT['term_3'].$qT['defn']));
		/* Add relation `user to term' */
		$q2['user_id'] = $oSess->user_get('id_user');
		$q2['term_id'] = $qT['id'];
		$q2['dict_id'] = $id_dict;
		// -------------------------------------------------
		// Turn on text parsers
		// -------------------------------------------------
		// Process automatic functions
		for (; list($k, $v) = each($gw_this['vars']['funcnames'][GW_A_UPDATE . GW_T_TERM]);)
		{
			if (function_exists($v))
			{
				$v();
			}
		}
		/* can be changed to `INSERT' but needs more testing */
		$queryA[] = gw_sql_replace($qT, $arDictParam['tablename'], 1);
		/* Assign edited term to user */
		$queryA[] = gw_sql_replace($q2, TBL_MAP_USER_TERM, 1);
	} /* is_query allowed */
	return $queryA;
}

/**
 * Adds a new keywords into TBL_WORDLIST and TBL_WORDMAP
 * @param int $id_dict dictionary ID
 * @param int $termId term ID
 * @param array $arKeywords Array with keywords per field
 * @param int $termIdOld
 * @param int $isClean
 */
function gwAddNewKeywords($id_dict, $id_term, $arKeywords, $termIdOld, $isClean)
{
	global $arFields, $intFields, $arStop, $sys;
	global $oDb, $oSqlQ;
#	@header("content-type: text/html; charset=utf-8");

#prn_r( $arKeywords );

	// Adding search keywords
	$arKeywordsJoin = array();
	for (reset($arKeywords); list($k, $v) = each($arKeywords);)
	{
		$arKeywordsJoin = array_merge($arKeywordsJoin, $v); // common array with all keywords
	}
	// unique keywords only, have to run second time
	$arKeywordsJoin = array_values(array_unique($arKeywordsJoin));
	$arQuery = array();
	$arSql = array();
	if (!empty($arKeywordsJoin))
	{
		$word_text_sql = "'" . implode("', '", $arKeywordsJoin) . "'";
		/* Get the list of already known keywords and their IDs */
		$arSql = $oDb->sqlExec($oSqlQ->getQ('get-word', TBL_WORDLIST, $word_text_sql));
	}
#    prn_r($arSql);
	$q2 = $q1 = array();
	if (!empty($arSql)) // some keywords are exist already
	{
		$cnt = 0;
		// for each founded keyword
		for (; list($arK, $arV) = each($arSql);)
		{
			if ($isClean) // overwrite mode
			{
				$arQuery[0] = $oSqlQ->getQ('del-wordmap-by-term-dict', $termIdOld, $id_dict);
			}
			$q2['word_id'] = $arV['word_id'];
			$q2['term_id'] = $id_term;
			$q2['dict_id'] = $id_dict;
			// Set index ID per field
			for (reset($arFields); list($id_field, $fV) = each($arFields);)
			{
				if (isset($arKeywords[$id_field]) && in_array($arV['word_text'], $arKeywords[$id_field]))
				{
					$q2['term_match'] = $id_field;
					$arQueryMapExist[] = gw_sql_insert($q2, TBL_WORDMAP, 1, $cnt);
					$keyId = gw_array_value($arKeywordsJoin, $arV['word_text']);
					unset($arKeywordsJoin[$keyId]); // remove existent keyword
					$cnt++;
				}
			}
		}
	}
	//
	// Add new kewords
#    prn_r($arKeywordsJoin);
#    prn_r($arKeywords);
	//
	$q2 = $q1 = array();
	$q1['word_id'] = $q2['word_id'] = ($oDb->MaxId(TBL_WORDLIST, 'word_id') - 1);
	$cnt = $cntMap = 0;
	// for each new keyword
	for (reset($arKeywordsJoin); list($k2, $v2) = each($arKeywordsJoin);)
	{
#		$v2 = gw_stripslashes($v2);
		$q2['word_id']++;
		$q2['dict_id'] = $id_dict;
		$q2['term_id'] = $id_term;
		$q1['word_id']++;
		$q1['word_text'] = '';
		//
		// Set index ID per field
		for (reset($arFields); list($id_field, $fV) = each($arFields);)
		{
			if (isset($arKeywords[$id_field]) && in_array($v2, $arKeywords[$id_field]))
			{
				$q2['term_match'] = $id_field;
				$q1['word_text'] = $v2;
				// add keyword into map
				$arQueryMap[] = gw_sql_insert($q2, TBL_WORDMAP, 1, $cntMap);
				$keyId = gw_array_value($arKeywordsJoin, $v2);
				unset($arKeywordsJoin[$keyId]); // remove new keyword
				$cntMap++;
			}
		}
		// add new word into wordlist
		if ($q1['word_text'] != '')
		{
			$arQueryWord[] = gw_sql_insert($q1, TBL_WORDLIST, 1, $cnt);
			$cnt++;
		}
	}
	/* Queries for existent keywords */
	if (isset($arQueryMapExist)) { $arQuery[] = implode('', $arQueryMapExist); }
	/* Queries for new keywords */
	if (isset($arQueryWord)) { $arQuery[] = implode('', $arQueryWord); }
	/* Queries for new keywords map */
	if (isset($arQueryMap)) { $arQuery[] = implode('', $arQueryMap); }
	/* Displays queries */
	if ($sys['isDebugQ'])
	{
		print '<ul class="sql"><li>'.implode(';</li><li>', $arQuery).';</li></ul>';
	}
	else
	{
		for (; list($kq, $vq) = each($arQuery);)
		{
			if (!$oDb->sqlExec($vq))
			{
				print '<li class="xt">Error: cannot exec query: '.$arQuery[$i].';</li>';
			}
		}
	}
}

/**
 *
 */
function sqlLock($tablename)
{
	return true; // disabled for a while
	global $oDb;
	if (!isset($oDb))
	{
		$oDb = new gwtkDb;
	}
	return $oDb->lock($tablename);
}
function sqlUnlock()
{
	return true; // disabled for a while
	global $oDb;
	if (!isset($oDb))
	{
		$oDb = new gwtkDb;
	}
	return $oDb->unlock();
}

function gw_get_databases()
{
	global $oDb, $sys;
	if (!defined('IS_CLASS_DB'))
	{
		include_once($sys['path_gwlib'] . '/class.db.mysql.php' );
	}
	if (!isset($oDb))
	{
		$oDb = new gwtkDb;
	}
	return $oDb->get_databases();
}

/**
 *
 */
function getTableInfo($tablename)
{
	global $oDb, $sys;
	if (!defined('IS_CLASS_DB'))
	{
		include_once($sys['path_gwlib'] . '/class.db.mysql.php' );
	}
	if (!isset($oDb))
	{
		$oDb = new gwtkDb;
	}
	return $oDb->table_info($tablename);
}

/**
 *
 * @param    string  $table       sql-table name // TODO: array
 * @param    int     $mode        [ 1 - structure | 2 - data | 3 - structure & data ]
 * @param    int     $func        [ 1 - insert | 2 - update ]
 * @param    string  $where       Dump only selected (28 may 2002)
 * @param    int     $isFields
 * @param    string  $limit       Apply "LIMIT n, n" to query
 */
function getTableStructure($tablename)
{
	global $oDb, $sys;
	if (!defined('IS_CLASS_DB'))
	{
		include_once( $sys['path_gwlib'] . '/class.db.mysql.php' );
	}
	if (!isset($oDb))
	{
		$oDb = new gwtkDb;
	}
	$strQ = '';
	$ar = array();
	// check for table name
	$isTable = 0;
	$arDbTables = $oDb->table_names($tablename);
	for (; list($k, $v) = each($arDbTables);)
	{
		if ($tablename == $v) { $isTable = 1; break; }
	}
	if (!$isTable) { return ''; }
#    if (!$isTable) { return 'ERROR: ' . $tablename . ' does not exist'; }
	// next
	$sql = 'SHOW CREATE TABLE `'. $tablename.'`';
	$arSql = $oDb->sqlExec($sql, '', 0);
	$arSql = isset($arSql[0]['Create Table']) ? $arSql[0] : array('Create Table');
	$strQ .= $arSql['Create Table'] . ';';
	return $strQ;
} // end of prepareSQLdum

#### -mySQL ####
// 1, Oct 2002
// 8 Feb 2005 - hexadecimal
function gw_sql_replace($arData, $tbl_name, $isFields = 1)
{
	$arFields = $arValues = array();
	$strFields = '';
	if (is_array($arData))
	{
		for (reset($arData); list($k, $v) = each($arData);)
		{
			$v = gw_text_sql($v);
			if ($v == ''){ $vF = "''"; }
			elseif ( preg_match("/^0x[0-9a-f]/", $v)) { $vF = $v; }
			else { $vF = "'" . $v . "'"; }
			$arFields[] = $k;
			$arValues[] = $vF;
		}
		if ($isFields) { $strFields = ' (' . implode(',', $arFields) . ')'; }
		$sql = CRLF . 'REPLACE INTO `' . $tbl_name .'`'. $strFields . ' VALUES ('.implode(',', $arValues).')';
		return $sql;
	}
	return false;
}

// 11 aug 2003: do not enclose with quotes all numerals
// 4 Oct 2002: short INSERT format (intCnt = [ 0, 1, 2 ... ]
// 24 May 2002: $isFields -- include field names to query or not
// 8 Feb 2005: no quotes for hexadecimal values
// 22 Feb 2005: DELAYED inserts
function gw_sql_insert($SQLnamesA, $table, $isFields = 1, $intCnt = 0, $is_delayed = 0)
{
	$query = '';
	$SQLfileds = '';
	$SQLfiledA = $SQLvalueA = array();
	if (is_array($SQLnamesA))
	{
		for (reset($SQLnamesA); list($k, $v) = each($SQLnamesA);)
		{
			$v = gw_text_sql($v);
			if ($v == '') {
				$vF = "''";
			}
			elseif ( preg_match("/^[0-9]{3,12}$/", $v) && !preg_match("/^[0-1]/", $v)
					||  preg_match("/^0x[0-9a-f]/", $v)) {
				// enum('0','1', .. ,'9'), timestamp(14), hex
				$vF = $v;
			}
			else {
				$vF = "'" . $v . "'";
			}
			$SQLfiledA[] = $k;
			$SQLvalueA[] = $vF;
		}
		$SQLvalues = implode(',', $SQLvalueA);
		if ($isFields) { $SQLfileds = ' (' . implode(',', $SQLfiledA) . ')'; }
		if (!$intCnt)
		{
			$query = CRLF.'INSERT '.($is_delayed ? 'DELAYED ': '').'INTO `' . $table .'`'. $SQLfileds . ' VALUES ('.$SQLvalues.')';
		}
		else
		{
			$query = ', ('.$SQLvalues.')';
		}
	}
	return $query;
} // end of function
/**
 *
 */
function gw_sql_update($SQLnamesA, $table, $where)
{
	$SQLratioA = array();
	for (reset($SQLnamesA); list($key, $val) = each($SQLnamesA);)
	{
		if (is_array($val)){
			$val = implode(',', $val);
		}
		$val = gw_text_sql($val);
		if ($val == ""){$valF = "'".$val."'";}
		else { $valF = "'".$val."'"; }
		$SQLratioA[] = "$key = $valF";
	}
	$SQLratioStr = implode(', ', $SQLratioA);
	$query = 'UPDATE `'.$table.'` SET '.$SQLratioStr.' WHERE '.$where;
	return $query;
}

#### /mySQL ####
?>