<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: func.srch.inc.php 84 2007-06-19 13:01:21Z yrtimd $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/)
 *   2002-2007 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Search functions
 *
 *  @package gw_search
 *  @version $Id: func.srch.inc.php 84 2007-06-19 13:01:21Z yrtimd $
 */
// --------------------------------------------------------

/**
 * Load the list of stopwords based on dictionary settings
 *
 * @param    array  $arDictParam Dictionary parameters
 * @return   array  Array with stopwords (if any)
 */
function gw_get_stopwords($arDictParam)
{
	global $oL;
	$arStop = array();
	if ($arDictParam['is_filter_stopwords'] && is_array($arDictParam['ar_filter_stopwords']))
	{
		for (reset($arDictParam['ar_filter_stopwords']); list($locale_id, $vS) = each($arDictParam['ar_filter_stopwords']);)
		{
			$arStop = array_merge($arStop, array_flip($oL->getCustom('stop_words', $locale_id, 'return')));
		}
		$arStop = array_keys($arStop);
	}
	return $arStop;
}

/**
 * Main function for searching terms
 *
 * @param    string  $q Search query string
 * @param    array   $arDict_Ids Dictionary IDs
 * @param    array   $srch Search parameters
 * @return   array   String term items, int total terms
 */
function gw_search($q, $arDict_Ids, $srch)
{
	global $arDictParam, $sys, $gw_this;
	global $oSqlQ, $oDb, $oHtml, $oFunc, $oL;
#@header('Content-Type: text/html; charset=UTF-8');
	/* */
	$arSql = array();
	$strA = array(0 => '', 1 => '');
	$tmp['arIn'] = $tmp['redirect_url'] = $tmp['arCache'] = $tmp['arResultsTmp'] = $tmp['arResults'] = array();
	$i = 0;
	/* Collect data for `gw_search_results' table */
	$tmp['arCache']['q'] = $q;
	$tmp['arCache']['found'] = 0;
	/* */
	if (!is_array($srch['in']))
	{
		$srch['in'] = array($srch['in']);
	}
	/* Save search parameters */
	$tmp['arCache']['srch_settings']['in'] = implode(',', $srch['in']);
	$tmp['arCache']['srch_settings']['srch_adv'] = $srch['adv'];
	$tmp['arCache']['srch_settings']['srch_by'] = $srch['by'];
	/* Use minimum search length */
	$arDictParam['min_srch_length'] = isset($arDictParam['min_srch_length']) ? $arDictParam['min_srch_length'] : 1;

	/* Enable wildcards */
	global $oCase;
	$oCase->set_replace_sp(array('*' => '*', '?' => '?'));

	if (GW_IS_BROWSE_ADMIN)
	{
		$page_index = $sys['page_admin'];
		$arKeywords = text2keywords( text_normalize($q), 1, 25, $sys['internal_encoding']);
		if ($q == '')
		{
			$tmp['arCache']['html'] = $oL->m('reason_5');
			return $tmp['arCache'];
		}
	}
	else
	{
		$page_index =& $sys['page_index'];
		$arKeywords = text2keywords( text_normalize($q), $arDictParam['min_srch_length'], 25, $sys['internal_encoding']);
		if ($oFunc->mb_strlen( str_replace('*', '', $q), $sys['internal_encoding'] ) < $arDictParam['min_srch_length'] )
		{
			$strA[0] = $oL->m('error');
			return $strA;
		}
	}
	/* Add visual theme to URL for redirect */
	if (!isset($gw_this['cookie']['gw_visualtheme']))
	{
		$tmp['redirect_url'][0] = 'visualtheme='.$sys['visualtheme'];
	}
	if (!isset($gw_this['cookie']['gw_'.GW_LANG_I]))
	{
		$tmp['redirect_url'][] = GW_LANG_I.'='.$gw_this['vars'][GW_LANG_I];
	}
	/* Search in single dictionary */
	$arStop = array();
	if (sizeof($arDict_Ids) == 1)
	{
		$tmp['arCache']['id_d'] = $arDict_Ids[0];
		$tmp['redirect_url'][0] = 'd=' . $arDict_Ids[0];
		/* Get stopwords */
		$arStop = gw_get_stopwords($arDictParam);
		$arKeywords = gw_array_exclude($arKeywords, $arStop);
	}
	$arStop = array();
	$tmp['intKeywords'] = sizeof($arKeywords);
	sort($arKeywords);
#	exit;
	// Assign `Unique ID' to query.
	// Already uppercased, without stopwords, without special symbols, alphabetically sorted. Nice.
	$tmp['arCache']['id_srch'] = md5(implode('', $arKeywords).implode('', $arDict_Ids).$tmp['arCache']['srch_settings']['in'].$srch['adv']);
	// -----------------------------------------------
	// Check for an existent query, if exists, get results and add hits + 1
	if ($srch['adv'] != 'phrase')
	{
		$arSql = $oDb->sqlExec($oSqlQ->getQ('srch-result-cnt', $tmp['arCache']['id_srch']));
	}
	$tmp['arCache']['hits'] = isset($arSql[0]['hits']) ? $arSql[0]['hits'] : 1;
	/* */
	if (GW_IS_BROWSE_WEB && !empty($arSql)) /* prev results found, web only */
	{
		$arSql = isset($arSql[0]) ? $arSql[0] : array();
		// Increase hits, web only
		// Can't place `hits' field into `srch_settings' because hits are used in SQL-requests
		$tmp['arCache']['hits'] = isset($arSql['hits']) ? $arSql['hits'] + 1 : 1;
		$tmp['arCache']['found'] = $arSql['found'];
		/* Update query text to show for user. */
		$oDb->sqlExec($oSqlQ->getQ('upd-srch-q', $tmp['arCache']['hits'], gw_text_sql($q), $tmp['arCache']['id_srch']));
	}
	else
	{
		$sql_term_match = '';
		$sql_table_match = '';
		$sql_term_match_all = '';
		/* Search in specified fields */
		if (!is_array($srch['in'])) { $srch['in'] = array(0); }
		switch($srch['in'][0])
		{
			case -1:
				/* search in terms and definitions, default */

			break;
			case 0:
				/* Search in definitions only */
				$sql_term_match = 'AND m.term_match != "1"';
			break;
			case 100:
				/* Search in unapproved */
				$sql_table_match = ', '.$arDictParam['tablename'].' AS dict';
				$sql_term_match = 'AND m.term_match = "1" AND dict.is_active = "0" AND dict.id = m.term_id';
				$sql_term_match_all = 'WHERE t.is_active = "0"';
			break;
			case 101:
				/* Search in incomplete */
				$sql_table_match = ', '.$arDictParam['tablename'].' AS dict';
				$sql_term_match = 'AND m.term_match = "1" AND dict.id = m.term_id';
				$sql_term_match_all = 'WHERE t.is_complete = "0"';
			break;
			default:
				/* search by fields */
				for (reset($srch['in']); list($inK, $inV) = each($srch['in']);)
				{
					$tmp['arIn'][] = $inV;
				}
				$sql_term_match = 'AND m.term_match IN (' . implode(', ', $tmp['arIn']) . ')';
			break;
		}
#		prn_r( $tmp );
#		exit;
		$oTm = new gw_timer('srch');
		/* Configure to search for 'all', 'phrase', 'any'; */
		if ( ($srch['adv'] == 'all') || ($srch['adv'] == 'phrase') )
		{
			/* Allows wildcard search */
			$arKeywords = gw_text_wildcars($arKeywords, 'sql');
			/* List all terms from one dictionary, for admin only */
			if (str_replace('*', '', $q) == '')
			{
				if (GW_IS_BROWSE_ADMIN)
				{
					$sql = $oSqlQ->getQ('get-terms-all-adm', $arDictParam['tablename'], $sql_term_match_all);
				}
				else
				{
					$sql = $oSqlQ->getQ('get-terms-all', $arDictParam['tablename'], $arDict_Ids[0]);
				}
				$arSql = $oDb->sqlExec($sql);
				/* Re-organize search results per dictionary */
				/* Limit the number of matched terms to 1000 */
				$int_cnt = 0;
				while ($int_cnt < 1000 && list($sqlK, $sqlV) = each($arSql))
				{
					$tmp['arResultsTmp'][$arDictParam['id']][$sqlV['term_id']][] = $sqlV['term_id'];
					$int_cnt++;
				}
				for (reset($tmp['arResultsTmp']); list($dictK, $resultsV) = each($tmp['arResultsTmp']);)
				{
					while (list($rK, $rV) = each($resultsV))
					{
						$tmp['arResults'][$dictK][] = $rK;
						$tmp['arCache']['found']++;
						$i++;
					}
					$tmp['arResults'][$dictK] = implode(',', $tmp['arResults'][$dictK]);
				}
			}
			else /* usual search */
			{
				/* Go for each word */
				for (reset($arKeywords); list($k, $v) = each($arKeywords);)
				{
					$sql_word_srch = "k.word_text LIKE '" . $v . "'";
					/* Main search query */
					if ($srch['adv'] == 'phrase')
					{
						$sql_table_match = ', '.$arDictParam['tablename'].' as t';
						$sql = $oSqlQ->getQ('srch-word-cnt-phrase', $sql_table_match, implode(',', $arDict_Ids), $sql_term_match, $sql_word_srch);
					}
					else
					{
						$sql = $oSqlQ->getQ('srch-word-cnt', $sql_table_match, implode(',', $arDict_Ids), $sql_term_match, $sql_word_srch);
					}
					$arSql = $oDb->sqlExec($sql);
					/* Re-organize search results per dictionary */
					/* Limit the number of matched terms to 1000 */
					$int_cnt = 0;
					/* $arSql has always at least one item in array */
					while ($int_cnt < 1000 && list($sqlK, $sqlV) = each($arSql))
					{
						if ($srch['adv'] == 'phrase')
						{
							/* We can select keywords from database or create new */
							$arKeywordsTerm = text2keywords( text_normalize($sqlV['term']), 1, 25, $sys['internal_encoding']);
#							$sql = $oSqlQ->getQ('srch-keyword-by-term',  implode(',', $arDict_Ids), $sql_term_match, $sqlV['term_id'] );
							sort($arKeywordsTerm);
							if (implode('', $arKeywordsTerm) == implode('', $arKeywords))
#							if (sizeof($arKeywordsTerm) == sizeof($arKeywords))
							{
								$tmp['arResultsTmp'][$sqlV['dict_id']][$sqlV['term_id']][] = $sqlV['term_id'];
								$int_cnt++;
							}
							else
							{
								continue;
							}
						}
						else
						{
							$tmp['arResultsTmp'][$sqlV['dict_id']][$sqlV['term_id']][] = $sqlV['term_id'];
							$int_cnt++;
						}
					}
					$arSql = array();
				}
#prn_r( $sql );
#exit;
				/* Now sort search results */
				for (reset($tmp['arResultsTmp']); list($dictK, $resultsV) = each($tmp['arResultsTmp']);)
				{
					/* Get stopwords per dictionary */
					$arThisDictParam = getDictParam($dictK);
					$arStop = gw_get_stopwords($arThisDictParam);
					$arKeywordsD = gw_array_exclude($arKeywords, $arStop);
					$tmp['intKeywords'] = sizeof($arKeywordsD);
					$tmp['arResults'][$dictK] = array();
					while (list($rK, $id_terms) = each($resultsV))
					{
						if ($srch['adv'] != 'phrase'
						  && sizeof($id_terms) != $tmp['intKeywords'])
						{
							/* not required, but it cleans some memory, I hope */
							unset($tmp['arResultsTmp'][$dictK][$rK]);
						}
						else
						{
							/* collect matched term IDs */
							$tmp['arResults'][$dictK][] = $rK;
							$tmp['arCache']['found']++;
							$i++;
						}
					}
					$tmp['arResults'][$dictK] = implode(',', $tmp['arResults'][$dictK]);
					if ($tmp['arResults'][$dictK] == '')
					{
						unset($tmp['arResults'][$dictK]);
					}
				}
			}
		}
#prn_r( $tmp );
#exit;
		/* Collect data for search log */
		$q_search['id_field'] = $tmp['arCache']['srch_settings']['in'];
		/* */
		$tmp['arCache']['srch_date'] = $sys['time_now_gmt_unix'];
		/* Save collected Term IDs */
		$tmp['arCache']['srch_settings']['results'] =& $tmp['arResults'];
		/* Save real search time (SQL + PHP) */
		/* probably should be changed to %1.3f */
		$tmp['arCache']['srch_settings']['time'] = sprintf("%1.5f", $oTm->end());
		/* Encode search results */
		$tmp['arCache']['srch_settings'] = serialize($tmp['arCache']['srch_settings']);
		/* ----------------------------------------------- */
		/* Add search results */
#		prn_r( $tmp['arCache'] );
#		if ($srch['adv'] != 'phrase')
#		{
			$oDb->sqlExec(gw_sql_replace($tmp['arCache'], $sys['tbl_prefix'] . 'search_results'), '', 0);
#		}
	}
#	prn_r( unserialize($tmp['arCache']['srch_settings']), __LINE__.' '.__FILE__);
#	prn_r($tmp['arResults'], __LINE__.' '.__FILE__);
#	prn_r($oDb->query_array);
#	exit;
##	$sys['is_delay_redirect'] = 1;
	/* Write search log */
	if (GW_IS_BROWSE_WEB && $sys['is_log_search'])
	{
		$q_search['id_dict'] = $gw_this['vars'][GW_ID_DICT];
		$q_search['found'] = $tmp['arCache']['found'];
		$q_search['date_created'] = $sys['time_now_gmt_unix'];
		$q_search['ip_long'] = $oFunc->ip2int(REMOTE_IP);
		$q_search['q'] = $tmp['arCache']['q'];
		$sql = gw_sql_insert($q_search, $sys['tbl_prefix'].'stat_search');
		$oDb->sqlExec($sql);
	}
	/* Only one term found, redirect to that term */
	if (GW_IS_BROWSE_WEB
	  && $srch['adv'] == 'phrase'
	  && isset($tmp['arCache']['srch_settings']['results'])
	  && ($tmp['arCache']['found'] == 1 || !empty($arSql))
	  )
	{
		$tmp['arCache']['srch_settings'] = unserialize($tmp['arCache']['srch_settings']);
		for (reset($tmp['arCache']['srch_settings']['results']); list($id_dict, $id_term) = each($tmp['arCache']['srch_settings']['results']);)
		{
			gwtk_header( $sys['server_proto'].$sys['server_host'] .
				$oHtml->url_normalize(
					$sys['page_index'].'?'.
					GW_ACTION .'='. GW_T_TERM. '&'.
					GW_ID_DICT .'='. $id_dict. '&'.
					GW_TARGET .'='.  $id_term
				), $sys['is_delay_redirect']
			);
		}
	}
	$tmp['redirect_url'][] = 'id_srch='.$tmp['arCache']['id_srch'];
	$tmp['redirect_url'][] = GW_ACTION.'='.GW_A_SEARCH;
	$tmp['redirect_url'][] = 'p=1';
	for (reset($sys['ar_url_append']); list($k, $v) = each($sys['ar_url_append']);)
	{
		$tmp['redirect_url'][] = $k.'='.$v;
	}
	gwtk_header( $oHtml->url_normalize($sys['server_proto'].$sys['server_host'].$page_index . '?'. implode('&', $tmp['redirect_url'])), $sys['is_delay_redirect']);
}


/**
 *
 */
function gw_search_results($id_srch, $p, $id_dict = 0)
{
	global $oDb, $oSqlQ, $oHtml, $oFunc, $oL, $oSess, $oTpl;
	global $sys, $strict, $gw_this, $ar_theme;
	global $arTplVars, $arDictParam;
	/* Clean old search results */
	gw_search_cleanup();
# header('Content-Type: text/html; charset=UTF-8');
	/* Select an existent query */
	$arSql = $oDb->sqlExec($oSqlQ->getQ('srch-result-id', $id_srch));
	$strA = array('found' => 0, 'found_total' => 0, 'q' => '', 'cur_id_dict' => 0, 'hits' => 0);
	
	/* No results */
	if (empty($arSql))
	{
		return $strA;
	}
	$arSql = isset($arSql[0]) ? $arSql[0] : array();
	/* insert all settings into the common array */
	$arSql = array_merge($arSql, unserialize($arSql['srch_settings']));
	unset($arSql['srch_settings']);
	/* */
#	prn_r($arSql, __LINE__.' '.__FILE__);
	/* */
	$arResults = array();
	/* get Dictionary IDs */
	$arSql['arDictIds'] = array_keys($arSql['results']);
	/* If requested dictionary is not in the search results, then reset to 0 */
	$id_dict = in_array($id_dict, $arSql['arDictIds']) ? $id_dict : 0;
	/* Go for each search results */
	for (reset($arSql['results']); list($dictK, $id_terms) = each($arSql['results']);)
	{
		/* Selected first dictionary from search results */
		$id_dict = ($id_dict == 0) ? $dictK : $id_dict;
		$tmp['arDictParam'] = getDictParam($id_dict);
		$arSql['found_total'] = $arSql['found'];
		$arSql['found'] = sizeof(explode(",", $arSql['results'][$id_dict]));
		$str_terms = $arSql['results'][$id_dict];
		/* Get founded terms in selected dictionary */
		if (GW_IS_BROWSE_ADMIN)
		{
			$arResults = $oDb->sqlExec(
						$oSqlQ->getQ('get-terms-in-adm', $tmp['arDictParam']['tablename'], $str_terms,
						$oDb->prn_limit($arSql['found'], $p, $sys['page_srch_limit'])) );
		}
		else
		{
			$arResults = $oDb->sqlExec(
						$oSqlQ->getQ('get-terms-in', $tmp['arDictParam']['tablename'], $str_terms,
						$oDb->prn_limit($arSql['found'], $p, $sys['page_srch_limit'])) );
		}
		break;
	}
	$gw_this['vars'][GW_ID_DICT] = $id_dict;
	if (empty($arResults))
	{
		$arSql['found_total'] = 0;
		return $arSql;
	}
	/* $id_dict is active */
	// --------------------------------------------------------
	// Settings for HTML-form
	// --------------------------------------------------------
#	$tpl_srch = new gwTemplate;
	// allow multilingual_vars
	gw_addon_multilingual_vars('', 'oTpl');
	//
	if (GW_IS_BROWSE_ADMIN)
	{
		/* Save search query */
		$oSess->user_set('id_search', $id_srch);
		$oSess->user_set('q', $arSql['q']);
		$oSess->user_set('in', $arSql['in']);
		$oSess->user_set('srch_adv', $arSql['srch_adv']);
		$oSess->user_set('srch_by', $arSql['srch_by']);
		$page_index = $sys['page_admin'];
#		$oTpl->addVal( "v:search_time",   sprintf("%1.5f", $arQ['time']) );

		$oTpl->addVal( 'l:1072', $oL->m('1072'));
		$oTpl->addVal( 'l:1071', $oL->m('1071'));
		$oTpl->addVal( 'l:1070', $oL->m('1070'));
		$oTpl->addVal( 'l:is_0', $oL->m('is_0'));
		$oTpl->addVal( 'l:is_1', $oL->m('is_1'));
		$oTpl->addVal( 'l:3_remove', $oL->m('3_remove'));
		$oTpl->addVal( 'l:select_on', $oL->m('select_on'));
		$oTpl->addVal( 'l:select_off', $oL->m('select_off'));
	}
	else
	{
		$page_index = $sys['page_index'];
		$oTpl->addVal( 'v:search_time',   sprintf("%1.3f", $arSql['time']) );
	}
	$srch['adv'] =& $arSql['srch_adv'];
	$srch['by'] =& $arSql['srch_by'];
	$srch['adv'] =& $arSql['srch_adv'];
	$arTplVars['srch'][] = array('chk_srch_in_term' => '' );
	$arTplVars['srch'][] = array('chk_srch_in_defn' => '' );
	$arTplVars['srch'][] = array('chk_srch_in_both' => '' );
	$arTplVars['srch'][] = array('chk_srch_in_term_unapproved' => '' );
	$arTplVars['srch'][] = array('chk_srch_in_term_incomplete' => '' );
	if ($arSql['in'] == -1)
	{
		$arTplVars['srch'][] = array('chk_srch_in_both' => ' checked="checked"' );
	}
	elseif ($arSql['in'] == 0)
	{
		$arTplVars['srch'][] = array('chk_srch_in_defn' => ' checked="checked"' );
	}
	elseif ($arSql['in'] == 1)
	{
		$arTplVars['srch'][] = array('chk_srch_in_term' => ' checked="checked"' );
	}
	elseif ($arSql['in'] == 100)
	{
		$arTplVars['srch'][] = array('chk_srch_in_term_unapproved' => ' checked="checked"' );
	}
	elseif ($arSql['in'] == 101)
	{
		$arTplVars['srch'][] = array('chk_srch_in_term_incomplete' => ' checked="checked"' );
	}
	$arA = gw_sql2defnpreview($arResults);

	$oHtml->setTag('a', 'style', 'text-decoration:underline');
	/* Resort dictionaries in alphabetic order */
	$arQ['arDictIdsSorted'] = array();
	for (reset($arSql['arDictIds']); list($k, $v_id_dict) = each($arSql['arDictIds']);)
	{
		$arThisDict = getDictParam($v_id_dict);
		$arSql['arDictIdsSorted'][$v_id_dict]['id'] = $arThisDict['id'];
		$arSql['arDictIdsSorted'][$v_id_dict]['title'] = $arThisDict['title'];
	}
	unset($arSql['arDictIds']);
	ksort($arSql['arDictIdsSorted']);
	$cnt_dicts = sizeof($arSql['arDictIdsSorted']);
	$tmp['dict_href'][1] = 'a=srch';
	$tmp['dict_href'][3] = 'id_srch='.$id_srch;
	$tmp['dict_href'][4] = 'p=1';
	for (reset($arSql['arDictIdsSorted']); list($k1, $arV) = each($arSql['arDictIdsSorted']);)
	{
		$str_found_dict = $k1;
		/* prepare the list of dictionaries with link to search results */
		$oTpl->tmp['d']['list_dict'][$k1]['v:found_dict'] = sizeof(explode(',', $arSql['results'][$arV['id']]));
		if (!isset($gw_this['cookie']['gw_visualtheme']) || $gw_this['cookie']['gw_visualtheme'] == '')
		{
			$tmp['dict_href'][5] = 'visualtheme='.$sys['visualtheme'];
		}
		if (!isset($gw_this['cookie']['gw_'.GW_LANG_I]) || $gw_this['cookie']['gw_'.GW_LANG_I] == '')
		{
			$tmp['dict_href'][6] = GW_LANG_I.'='.$gw_this['vars'][GW_LANG_I];
		}
		$tmp['dict_href'][2] = 'd='.$arV['id'];
		$oTpl->tmp['d']['list_dict'][$k1]['url:dict_url_search'] = $oHtml->a($page_index.'?'.implode('&', $tmp['dict_href']), strip_tags($arV['title']));
		
		/* unlink current dictoinary */
		if ($arV['id'] == $id_dict)
		{
			$oTpl->tmp['d']['list_dict'][$k1]['url:dict_url_search'] = '&gt;'.strip_tags($arV['title']);
			$arSql['cur_dict_title'] = strip_tags($arV['title']);
			$arSql['cur_id_dict'] = $id_dict;
		}
	}
	if ($cnt_dicts == 1)
	{
		#$arDictParam = getDictParam($arV['id']);
		$arDictParam =& $arThisDict;
	}
	$oHtml->setTag('a', 'style', '');
	$cnt = 0;
	/* For each re-formated results */
	for (reset($arA); list($k1, $v1) = each($arA);)
	{
		/* Collect data for template */
		$oTpl->tmp['d']['search_item'][$k1]['v:term_number'] = (($p-1) * $sys['page_srch_limit']) + $k1 + 1;
		$oTpl->tmp['d']['search_item'][$k1]['v:color_odd_even'] = ($cnt % 2 ) ? $ar_theme['color_2'] : $ar_theme['color_1'];
		$oTpl->tmp['d']['search_item'][$k1]['v:id_term'] = $v1['t_id'];
		if (GW_IS_BROWSE_ADMIN)
		{
			$oTpl->tmp['d']['search_item'][$k1]['v:term'] = $oHtml->a( $page_index
											. '?'. GW_ACTION .'='. GW_A_EDIT .'&'. GW_TARGET .'='. GW_T_TERM . '&id=' . $v1['d_id']
											. '&tid='.$v1['t_id'],
											text_highlight($v1['term'], $arSql['q'])
											);
			$oTpl->tmp['d']['search_item'][$k1]['v:status'] = $v1['is_active'] ? '' : '<span class="red">'.$oL->m('is_0').'</span>';
			$oTpl->tmp['d']['search_item'][$k1]['url:term_edit'] = $oHtml->a($page_index
											. '?'. GW_ACTION . '=' . GW_A_EDIT . '&' . GW_TARGET . '=' . GW_T_TERM . '&id=' . $v1['d_id']
											. '&tid='.$v1['t_id'], $oL->m('3_edit'));
			$oTpl->tmp['d']['search_item'][$k1]['url:term_remove'] = $oHtml->a($page_index
											. '?'. GW_ACTION . '=' . GW_A_REMOVE . '&' . GW_TARGET . '=' . GW_T_TERM . '&id=' . $v1['d_id']
											. '&tid='.$v1['t_id'], $oL->m('3_remove'));
		}
		else
		{
			/* link from search results */
			$oTpl->tmp['d']['search_item'][$k1]['v:term'] = $oHtml->a($page_index
											. '?'.GW_ACTION .'='. GW_T_TERM .'&d='. $v1['d_id'] .'&'. GW_TARGET.'=' . $v1['t_id'],
											text_highlight($v1['term'], $arSql['q'], $sys['internal_encoding']));

			if (is_object($oSess) && $oSess->is_allow('term_edit_other', $arDictParam['id']))
			{
				$oTpl->tmp['d']['search_item'][$k1]['url:term_edit'] = $oHtml->a($sys['page_admin']
											. '?'. GW_ACTION . '=' . GW_A_EDIT . '&' . GW_TARGET . '=' . GW_T_TERM . '&id=' . $v1['d_id']
											. '&tid='.$v1['t_id'], $oL->m('3_edit'));
				$oTpl->tmp['d']['search_item'][$k1]['url:term_remove'] = $oHtml->a($sys['page_admin']
											. '?'. GW_ACTION . '=' . GW_A_REMOVE . '&' . GW_TARGET . '=' . GW_T_TERM . '&id=' . $v1['d_id']
											. '&tid='.$v1['t_id'], $oL->m('3_remove'));
			}
		}
		$oTpl->tmp['d']['search_item'][$k1]['v:defn'] = text_highlight($v1['defn'], $arSql['q'], $sys['internal_encoding']);
		$cnt++;
	}
	$oTpl->addVal( 'v:cnt_term_start', (($p-1) * $sys['page_srch_limit']) + 1);
	$oTpl->addVal( 'v:cnt_term_end',  (($p-1) * $sys['page_srch_limit']) + 1 + $cnt);
	if (GW_IS_BROWSE_WEB && $ar_theme['columns'] > 1)
	{
		include_once( $sys['path_gwlib'] . '/class.cells_tpl.php' );
		$oCells = new gw_cells_tpl();
		$oCells->class_tpl = $sys['class_tpl'];
		$oCells->tpl = 'tpl_cells_term';
		$oCells->id_theme = $gw_this['vars']['visualtheme'];
		$oCells->arK =& $oTpl->tmp['d']['search_item'];
		$oCells->X = $ar_theme['columns'];
		$oCells->Y = $sys['page_limit'];
		$oCells->int_page = $gw_this['vars']['p'];
		$oCells->is_odd = 1;
		$oCells->tSpacing = 1;
		$oCells->tPadding = 0;
		$oCells->tAttrClass = 'tbl-browse';
		$oTpl->addVal( 'block:columns', $oCells->output());
		$oTpl->tmp['d']['list_item'] = array();
	}
	else if (GW_IS_BROWSE_WEB)
	{
		$oTpl->tmp['d']['if:one_column'] = true;
	}
	return $arSql;
}


/**
 * Cleans search results table.
 * Removes old queries
 */
function gw_search_cleanup()
{
	global $oDb, $oSqlQ, $sys;
	$sql = sprintf('DELETE FROM %s WHERE srch_date < %d',
			$sys['tbl_prefix'].'search_results',
			$sys['time_now_gmt_unix'] - ($sys['max_days_searchcache'] * 24) * 60 * 60);
	$oDb->sqlExec($sql);
	$sql = sprintf('DELETE FROM %s WHERE date_created < %d',
			$sys['tbl_prefix'].'stat_search',
			$sys['time_now_gmt_unix'] - ($sys['max_days_searchlog'] * 24) * 60 * 60);
	$oDb->sqlExec($sql);
	$oDb->sqlExec('CHECK TABLE '.$sys['tbl_prefix'].'stat_search');
}

/* end of file */
?>